#include "stdafx.h"
#include "MakeTerrain.h"

#include "ObjetTroisD.h"
#include "math.h"
#include "mainfrm.h"


#include "MakeTerrainDoc.h"
extern CMakeTerrainDoc * pDoc;




// Liste des variables externes
extern CMakeTerrainApp theApp;
GLfloat mattmp16 [16];
GLfloat matrot [16];
GLfloat T [16];


POINTASC pt;
int TextureIdentification = 0;
int IdentificationObjet = 0;
int CompteObjetAnime;
CMatrice MatObj;

GLfloat PIMUL = (float) (3.1415927/180);
GLfloat PIMULMISSILAUTO = (float) (180/3.1415927);






Objet :: Objet (int nVertexInit,int nFacetteInit)
{
	// Initialisation des donnes interne
	NbTextCoord = 0;
	NbVertex = nVertexInit;
	NbFacette = nFacetteInit;
	NbTotal = nVertexInit + NPOINTCOLLISION;

	hglbPoint		= NULL;
	hglbFace		= NULL;
	hglbTextCoord	= NULL;

	// Allouer l'objet
	AllocMemory ();

	// Initialisation de la texture par defaut
	Texture.Height = -1;
	Texture.Width = -1;
	Texture.pBit = NULL;

	Rayon = 0;

	TextureListe.RemoveAll ();

	noCallListe = -1;
}


Objet :: ~Objet ()
{
	DestroyMemory ();

	// Detruire la liste de texture
	POSITION pos;
	int count;
	CTextureInfo * pTextureInfo;
	count = TextureListe.GetCount ();
	for (int i = 0; i < count ; i++)
	{
		pos = TextureListe.FindIndex (i);
		if (pos)
		{
			pTextureInfo = (CTextureInfo *) TextureListe.GetAt (pos);
			if (pTextureInfo) delete pTextureInfo;
		}
	}

	// Detruire la liste
	TextureListe.RemoveAll ();
}


void Objet :: SetFileName (CString FileNameInit)
{
	FileName = FileNameInit;
	IdObjet = IdentificationObjet++;
}

void Objet :: AllocMemory ()
{
	HGLOBAL hglb;
	POINTASC * pPointAsc;
	FACETTE * pFacetteAsc;
	int i;
	

	// Allocation de la memoire
	hglbPoint	= GlobalAlloc (GPTR,NbTotal * sizeof (POINTASC *));
	hglbFace	= GlobalAlloc (GPTR,NbFacette * sizeof (FACETTE *));
	pPoint = (POINTASC **) GlobalLock (hglbPoint);
	pFacette = (FACETTE **) GlobalLock (hglbFace);

	

	// Allocation de N Vertex structure
	for (i = 0; i < NbTotal; i++)
	{
		hglb = GlobalAlloc (GPTR,sizeof (POINTASC));
		pPointAsc = (POINTASC *) GlobalLock (hglb);

		pPoint [i] = pPointAsc;
	}

	// Allocation de N Facette structure
	for (i = 0; i < NbFacette; i++)
	{
		hglb = GlobalAlloc (GPTR,sizeof (FACETTE));
		pFacetteAsc = (FACETTE *) GlobalLock (hglb);

		pFacette [i] = pFacetteAsc;
		
		// Normal  NULL au dpart
		pFacetteAsc->norm = NULL;
	}
}


void Objet :: AllocTextureCoord (int NbreCoord)
{
	HGLOBAL hglb;
	POINTASC * pPointAsc;
	int i;
	

	// Ne as allouer deux fois
	if (hglbTextCoord) return;

	// NbTextCoord initialisation
	NbTextCoord = NbreCoord;

	// Allocation de la memoire
	hglbTextCoord	= GlobalAlloc (GPTR,NbreCoord * sizeof (POINTASC *));
	pTextCoord = (POINTASC **) GlobalLock (hglbTextCoord);
	

	// Allocation de N Vertex structure
	for (i = 0; i < NbreCoord; i++)
	{
		hglb = GlobalAlloc (GPTR,sizeof (POINTASC));
		pPointAsc = (POINTASC *) GlobalLock (hglb);

		pTextCoord [i] = pPointAsc;
	}
}



void Objet :: SetPoint (int no,GLfloat x,GLfloat y,GLfloat z)
{
	POINTASC * pPointAsc;
	if (no < 0 || no >= NbTotal) return;
	pPointAsc = GetPoint (no);
	if (pPointAsc == NULL) return;
	
	// Initialiser les points
	pPointAsc->x = x;
	pPointAsc->y = y;
	pPointAsc->z = z;
}


POINTASC * Objet :: GetPoint (int no)
{
	if (no < 0 || no >= NbTotal) return NULL;
	return pPoint [no];
}

void Objet :: SetFacette (int no,int a,int b,int c,int TextIndex)
{
	FACETTE * pFacetteAsc;
	if (no < 0 || no >= NbFacette) return;
	pFacetteAsc = GetFacette (no);
	if (pFacetteAsc == NULL) return;
	
	// Initialiser les points
	pFacetteAsc->a = a;
	pFacetteAsc->b = b;
	pFacetteAsc->c = c;
	pFacetteAsc->TextIndex = TextIndex;
}



void Objet :: SetFacetteNormale (int no,NORMAL * norm)
{
	FACETTE * pFacetteAsc;
	if (no < 0 || no >= NbFacette) return;
	pFacetteAsc = GetFacette (no);
	if (pFacetteAsc == NULL) return;
	
	// Initialiser les points
	pFacetteAsc->norm = norm;
}



POINTASC * Objet :: GetTextCoord (int no)
{
	if (no < 0 || no >= NbTextCoord) return NULL;
	return pTextCoord [no];
}

BOOL Objet :: SetTextCoord (int no,GLfloat x,GLfloat y,GLfloat z)
{
	POINTASC *pt;
	if (no < 0 || no >= NbTextCoord) return FALSE;
	pt = GetTextCoord (no);
	if (!pt) return FALSE;
	pt->x = x;
	pt->y = y;
	pt->z = z;
	return TRUE;
}

BOOL Objet :: SetTextCoordIndex (int no,int Ta,int Tb,int Tc)
{
	FACETTE * pFacette = NULL;
	if (no < 0 || no >= NbFacette) return FALSE;
	pFacette = GetFacette (no);
	if (!pFacette) return FALSE;
	pFacette->Tcoord [0] = Ta;
	pFacette->Tcoord [1] = Tb;
	pFacette->Tcoord [2] = Tc;
	return TRUE;
}






FACETTE * Objet :: GetFacette (int no)
{
	if (no < 0 || no >= NbFacette) return NULL;
	return pFacette [no];
}


void Objet :: DestroyMemory ()
{
	HGLOBAL hglb;
	POINTASC * pPointAsc;
	FACETTE * pFacetteAsc;
	int i;

	// Allocation de N Vertex structure
	for (i = 0; i < NbVertex; i++)
	{
		pPointAsc = GetPoint (i);
		if (pPointAsc)
		{
			hglb = GlobalHandle (pPointAsc);
			if (hglb) 
			{
				GlobalUnlock (hglb);
				GlobalFree (hglb);
			}
		}
	}

	// Detruire l'allocation pour les coordonnee de texture
	for (i = 0; i < NbTextCoord; i++)
	{
		pPointAsc = GetTextCoord (i);
		if (pPointAsc)
		{
			hglb = GlobalHandle (pPointAsc);
			if (hglb) 
			{
				GlobalUnlock (hglb);
				GlobalFree (hglb);
			}
		}
	}


	// Allocation de N Facette structure
	for (i = 0; i < NbFacette; i++)
	{
		pFacetteAsc = GetFacette (i);
		if (pFacetteAsc)
		{
			
			if (pFacetteAsc->norm != NULL){
				hglb = GlobalHandle (pFacetteAsc->norm);
				if (hglb) 
				{
					GlobalUnlock (hglb);
					GlobalFree (hglb);
				}
			}

			hglb = GlobalHandle (pFacetteAsc);
			if (hglb) 
			{
				GlobalUnlock (hglb);
				GlobalFree (hglb);
			}
		}
	}

	// Liberer le pointeur de pointeur des points
	if (hglbPoint)
	{
		GlobalUnlock (hglbPoint);
		GlobalFree (hglbPoint);
	}

	// Liberer le pointeur de pointeur des facettes
	if (hglbFace)
	{
		GlobalUnlock (hglbFace);
		GlobalFree (hglbFace);
	}

	// Liberer le pointeur de pointeur des coordo de textures
	if (hglbTextCoord)
	{
		GlobalUnlock (hglbTextCoord);
		GlobalFree (hglbTextCoord);
	}

	

}

// Cette fonction n'est peut etre pas esthetic mais j'emmerde tous ceux
// 
void Objet :: InitCubeCollision ()
{
	int i;
	POINTASC *pt;
	GLfloat gauche,droit;
	GLfloat haut,bas;
	GLfloat devant,arriere;
	GLfloat xr,yr,zr;
	GLfloat RayonPoint;


	// Initialisation des points de rfrence  0
	gauche = 0;
	droit = 0;
	haut = 0;
	bas = 0;
	devant = 0;
	arriere = 0;

	
	// Initialisation de chaque point
	for (i = 0; i < NbVertex; i++)
	{
		pt = GetPoint (i);

		if (pt->x < gauche) gauche = pt->x;
		if (pt->x > droit) droit = pt->x;

		if (pt->y > haut) haut = pt->y;
		if (pt->y < bas) bas = pt->y;

		if (pt->z < devant) devant = pt->z;
		if (pt->z > arriere) arriere = pt->z;


		// On calcul le rayon des trois points et si sa valeur
		// est plus grande que celle mmoris dan Rayon
		// alors on la sauvegarde
		xr = abs (pt->x);
		yr = abs (pt->y);
		zr = abs (pt->z);
		RayonPoint = sqrt (xr*xr+yr*yr+zr*zr);
		if (RayonPoint > Rayon) Rayon = RayonPoint;
	
	}


		
	// HAUT GAUCHE DEVANT
	SetPoint (NbVertex,gauche,haut,devant);

	// HAUT DROIT DEVANT
	SetPoint (NbVertex+1,droit,haut,devant);

	// HAUT GAUCHE ARRIERE
	SetPoint (NbVertex+2,gauche,haut,arriere);

	// HAUT DROIT ARRIERE
	SetPoint (NbVertex+3,droit,haut,arriere);


	
	
	// BAS GAUCHE DEVANT
	SetPoint (NbVertex+4,gauche,bas,devant);

	// BAS DROIT DEVANT
	SetPoint (NbVertex+5,droit,bas,devant);

	// BAS GAUCHE ARRIERE
	SetPoint (NbVertex+6,gauche,bas,arriere);

	// BAS DROIT ARRIERE
	SetPoint (NbVertex+7,droit,bas,arriere);

}


// Renvoit la longueur du cube de collision sur X
GLfloat Objet :: GetCoteX ()
{
	POINTASC * p1;
	POINTASC * p2;
	p1 = GetPoint (NbVertex);
	p2 = GetPoint (NbVertex+1);

	return (p2->x - p1->x);
}

// FileIndexe est l'index du materiel dans le ficiher ASE
// Cet index ne correspond pas forcement avec l'index
// dans la liste des texture d'un objet 3D
// on le memorise donc pour le remetre les indexes
// de textures des facettes en phase avec l'indexe dans la liste.
void Objet :: AddTexture (CString fileName,int FileIndexe)
{
	
	CTextureInfo	 * pTextInfo = NULL;
	pTextInfo = new CTextureInfo (fileName);
	if (pTextInfo == NULL) return;
	

	pTextInfo->SetIndexe (FileIndexe);
	TextureListe.AddTail (pTextInfo);
}

// Cette methode est utilise pour remetre d'aplond tou les indexes
// de textures pour chaque facette en fonction des indexes de fichier
void Objet :: MakeIndexeTexture ()
{
	POSITION pos;
	FACETTE * pFacette;
	CTextureInfo	 * pTextInfo = NULL;
	int i,j;
	int count = TextureListe.GetCount ();

	for (i = 0; i < count ; i++)
	{
		pos = TextureListe.FindIndex (i);
		if (pos) 
		{
			pTextInfo = (CTextureInfo *) TextureListe.GetAt (pos);
		
			if (pTextInfo != NULL)
			{
				
				for (j = 0; j < NbFacette ; j++)
				{
					pFacette = GetFacette (j);
					if (pFacette) 
					{
						if (pFacette->TextIndex == pTextInfo->GetIndexe ())
							pFacette->TextIndex = i;

					}
				}
			}
		}
	}


}


BOOL Objet :: SelectTexture (int IndexeDeListe)
{
	
	POSITION pos = NULL;
	CTextureInfo * pText = NULL;
	pos = TextureListe.FindIndex (IndexeDeListe);
	if (pos)
	{
		TEXTUREINFO * pTextInfo;

		pText = (CTextureInfo *) TextureListe.GetAt (pos);
		if (pText)
		{
			pTextInfo = pText->GetTextureInfo ();
			glBindTexture(GL_TEXTURE_2D,pText->GetID());

		}
	}
	else return FALSE;
	return TRUE;

}

// Cette fonction renvoit l'identifiant d'une texture
//  partir de son index dans la liste des textures
int Objet :: GetTextureId (int no){
	POSITION pos = NULL;
	CTextureInfo * pText = NULL;
	pos = TextureListe.FindIndex (no);
	if (pos == NULL) return -1;

	TEXTUREINFO * pTextInfo;
	pText = (CTextureInfo *) TextureListe.GetAt (pos);
	if (pText == NULL) return -1;

	pTextInfo = pText->GetTextureInfo ();
	return pText->GetID();
}



// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
//					VAISSEAU
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------


CShip :: CShip (Objet * objinit)
{
	NoObj = CompteObjetAnime ++;
	dx = dy = dz =0;
	x = y = z = 0;
	obj = objinit;
	vitesse = 0;

	IdExplosion = -1;
	bExplose = FALSE;

	// Initialiser la matrice de rfrence  son identit
	MatObj.MatriceToIdentity (matref);

	// Par defaut au dbut il est en vie
	bDestroyed = FALSE;

	PhiAxMem = 0;
	PhiAyMem = 0;

	// Angle de rotation maximal de pivot lors que celui ci est lock
	LockAngle = 5;


	// Vitesse maximum
	vitesseMax = 1000000;

	any = any = anz = 0;

	IndexTriangle = 0;
}
	
CShip :: ~CShip ()
{
	delete obj;
}

void CShip :: Explode ()
{
	bExplose = TRUE;
	IdExplosion = 0;

	anx = any = anz = 0;

}


void CShip :: Deplace ()
{
	x += (GLfloat) dx;
	y += (GLfloat) dy;
	z += (GLfloat) dz;

	matref [12] = x+dx;
	matref [13] = y;
	matref [14] = z+dz;
}

void CShip :: SetY (GLfloat yInit)
{
	y = yInit;
	matref [13] = y;
}







void CShip :: InitDirection (GLfloat xdir,GLfloat ydir,GLfloat zdir)
{
	GLfloat dix,diy,diz;

	// Calculer le distance entre le missil et la cible
	dix = x - xdir;
	diy = y - ydir;
	diz = z - zdir;

	// Initialisation des angles de position du missil
	PhiAxMem = atan2(-dy,sqrt(dz*dz+dx*dx))*180/PI;
	PhiAyMem = -atan2(dx,-dz)*180/PI;

}

// Cette mthode donne une direction au vaisseau
// Cette mthode est appele en exterieur
void CShip :: SetDirection (GLfloat xdir,GLfloat ydir,GLfloat zdir)
{

	GLfloat dix,diy,diz;
	GLfloat PhiAx,PhiAy;
	GLfloat DifAx,DifAy;

	// Calculer le distance entre le missil et la cible
	dix = x - xdir;
	diy = y - ydir;
	diz = z - zdir;

		
	// -------------- AX HAUT BAS --------------
	PhiAx = atan2 (diy,sqrt (diz*diz+dix*dix)) * PIMULMISSILAUTO;

	// -------------- AY DROITE GAUCHE --------------
	PhiAy = atan2 (dix,diz) * PIMULMISSILAUTO;


	// Calculer les diffrences d'angle entre l'angle mmorise prcdement
	// et celui dcrit par le vecteur de missil.
	// Cette diffrence permet de nous donne l'angle exacte qui pemet de s'aligner
	// sur la cible sur les deux plans.
	DifAx = PhiAx - PhiAxMem;
	DifAy = PhiAy - PhiAyMem;


	// Si l'angle est suprieur  180 alors on augmente de 360 pour
	// prendre le chemin le plus court
	if (abs (DifAy) > 180)	DifAy += (DifAy < 0) ? 360 : -360;
	if (abs (DifAx) > 180)  DifAx += (DifAx < 0) ? 360 : -360;

/*
	// Si les diffrences sont suprieur  la rotation max du missil alors
	// ajouste par cette capacit maximum
	if (abs (DifAx) > LockAngle)
			DifAx = (DifAx <0)	? -LockAngle : LockAngle;

	if (abs (DifAy) > LockAngle)
			DifAy = (DifAy <0)	? -LockAngle : LockAngle;
			*/


	PhiAxMem += DifAx;
	PhiAyMem += DifAy;

	MatObj.SetMatrice (mattmp16,PhiAxMem,0,0);
	MatObj.SetMatrice (matref,0,-PhiAyMem,0);
	MatObj.MulMatrice (matref,mattmp16);


	// Incrmentation des coordonnes du missile
	SetDep ();


}


void CShip :: SetOrientation (GLfloat AngX,GLfloat AngZ)
{
	anx = AngX;
	anz = AngZ;
}




POINTASC CShip :: Normal (float x,float y,float z,float vecx,float vecy,float vecz)
{
	POINTASC pt;
	pt.x = y * vecz - vecy * z;
	pt.y = z * vecx - vecz * x;
	pt.z = x * vecy - vecx * y;
	return pt;
}

// 0	4	8	12
// 1	5	9	13
// 2	6	10	14
// 3	7	11	15
void CShip :: SetOrientation (GLfloat xn,GLfloat yn,GLfloat zn,int no)
{
	POINTASC ptAsc;
	POINTASC_TERRE N;
	POINTASC_TERRE Nx;
	POINTASC_TERRE Nz;
	float len;



   	N.x = xn;
	N.y = yn;
	N.z = zn;

	Nz.x = matref [8];
	Nz.y = matref [9];
	Nz.z = matref [10];


	// Calcul du vecteur Nx
	ptAsc = Normal (N.x,N.y,N.z,Nz.x,Nz.y,Nz.z);
	Nx.x = ptAsc.x;
	Nx.y = ptAsc.y;
	Nx.z = ptAsc.z;

	// Normaliser le vecteur Nx
	len = sqrt (Nx.x*Nx.x + Nx.y*Nx.y +Nx.z*Nx.z);
	Nx.x /= len;
	Nx.y /= len;
	Nx.z /= len;
	matref [0] = Nx.x;
	matref [1] = Nx.y;
	matref [2] = Nx.z;



	// Vecteur Normal de la facette
	matref [4] = N.x;
	matref [5] = N.y;
	matref [6] = N.z;


	// Calcul du vecteur normal de direction
	ptAsc = Normal (N.x,N.y,N.z,Nx.x,Nx.y,Nx.z);
	Nz.x = ptAsc.x;
	Nz.y = ptAsc.y;
	Nz.z = ptAsc.z;

	len = sqrt (Nz.x*Nz.x + Nz.y*Nz.y +Nz.z*Nz.z);
	Nz.x /= len;
	Nz.y /= len;
	Nz.z /= len;
	matref [8] = -Nz.x;
	matref [9] = -Nz.y;
	matref [10] = -Nz.z;
}



void CShip :: Rot (GLfloat ax,GLfloat ay,GLfloat az)
{

	any += ay;
	MatObj.SetMatrice (mattmp16,0,ay,0);
	MatObj.MulMatrice (matref,mattmp16);


	SetDep ();

	matref [12] = x;
	matref [13] = y;
	matref [14] = z;
}


void CShip :: SetDep ()
{
	dx = matref [8] * vitesse;
	dy = matref [9] * vitesse;
	dz = matref [10] * vitesse;
}

void CShip :: Raz ()
{

	MatObj.MatriceToIdentity (matref);
	vitesse = 0;
	x = y = z = 0;
	Rot (0,0,0);
}

POINTASC * CShip :: GetPoint (int index)
{
	return obj->GetPoint (index);
}

POINTASC * CShip :: GetPointCollision (int index)
{
	return obj->GetPoint (obj->GetNbVertex () + index);
}

/*
0	1	2	3
4	5	6	7
8	9	10	11
12	13	14	15
*/
void CShip :: CopyMatrice (GLfloat matToCopy [16])
{
	
	// Copier la matrice
	memcpy (matref,matToCopy,sizeof (matref));
	SetDep ();

	matref [12] = x;
	matref [13] = y;
	matref [14] = z;
}



void CShip :: Draw ()
{
	glPushMatrix();
	glColor4f (1,1,1,1);
	glMultMatrixf (matref);
	glCallList (obj->noCallListe);
	glPopMatrix();
}



// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
//								TEXTURE CLASSE
// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
CTextureInfo :: CTextureInfo(CString filename,BOOL bChargementNormal)
{
	// Par defaut bChargementNormal est  FALSE cela indique que l'on charge une texture
	// depuis un fichier ASE, sinon si la variable est TRUE alors on charge
	// depuis un chemin normal
	if (!bChargementNormal) FileName = filename.Mid(1,filename.GetLength()-3);
	else FileName = filename;

	IdTexture = TextureIdentification ++; 			

	// Chargement de la texture
	TextInfo.pBit = 0;
	Load ();
}

CTextureInfo :: CTextureInfo(int Cx,int Cy)
{
	TextInfo.Width = Cx;
	TextInfo.Height = Cy;
	TextInfo.pBit = (unsigned char *) malloc(TextInfo.Width * TextInfo.Height * 4);
	memset (TextInfo.pBit,0,TextInfo.Width * TextInfo.Height * 4);
}



CTextureInfo :: ~CTextureInfo()
{
	// Librer la memoire alloue
	if (TextInfo.pBit != NULL) free (TextInfo.pBit);
}

BOOL CTextureInfo :: Load ()
{
	FILE * File;
	BITMAPFILEHEADER FileHeader;
	BITMAPINFOHEADER InfoHeader;
	DWORD Type;
	RGBTRIPLE rgb;
	int i, j, o=0;


	// open filename for reading
	File = fopen(FileName, "rb");
	if (!File) return FALSE;

	// read the header and type, then seek to the next position
	fread(&FileHeader, sizeof(FileHeader), 1, File);
	fread(&Type, sizeof(Type), 1, File);
	fseek(File, sizeof(FileHeader), SEEK_SET);

	// read the infoheader
	fread(&InfoHeader, sizeof(InfoHeader), 1, File);


	// set our texture width and height from what is read in the file
	TextInfo.Width = InfoHeader.biWidth;
	TextInfo.Height = abs (InfoHeader.biHeight);

	// allocate enough memory to store the bitmap, then fill the memory with zeros
	// this size is width * height * 4
	// 4 means 1 byte for red, green, blue, and alpha
	TextInfo.pBit = (unsigned char *) malloc(TextInfo.Width * TextInfo.Height * 4);
	if (TextInfo.pBit == NULL) return FALSE;
	
	memset(TextInfo.pBit, 0, TextInfo.Width * TextInfo.Height * 4);
	


	// loop through loading pixel by pixel
	for (j=0; j < InfoHeader.biHeight; j++) {

		for (i=0; i < InfoHeader.biWidth; i++) {

			// load the r g and b values from the file into an RGBTRIPLE structure
			fread(&rgb, sizeof(rgb), 1, File);

			// color is not averaged, so get the pixels normally
			TextInfo.pBit[o+0] = rgb.rgbtRed;
			TextInfo.pBit[o+1] = rgb.rgbtGreen;
			TextInfo.pBit[o+2] = rgb.rgbtBlue;
			
			// ALPHATEST
			TextInfo.pBit[o+3] = 255;

			o += 4;
		}
	}

	fclose(File);

/*
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	*/


	glBindTexture(GL_TEXTURE_2D,IdTexture);
//	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
//	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
//	glTexImage2D(GL_TEXTURE_2D, 0, 4, TextInfo.Width,TextInfo.Height, 0, GL_RGBA, GL_UNSIGNED_BYTE,TextInfo.pBit);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);

	
	gluBuild2DMipmaps(GL_TEXTURE_2D, 4,TextInfo.Width,TextInfo.Height,GL_RGBA, GL_UNSIGNED_BYTE,TextInfo.pBit);

	return TRUE;
}


void CTextureInfo :: GetRgb (int i,int j,BYTE &r,BYTE &g,BYTE &b)
{
	BYTE * pt;


	pt = TextInfo.pBit + (j * TextInfo.Height * 4) + i * 4;
	r = *pt;
	g = *(pt+1);
	b = *(pt+2);
}

void CTextureInfo :: SetRgb (int i,int j,BYTE r,BYTE g,BYTE b)
{
	BYTE * pt;
	pt = TextInfo.pBit + (j * TextInfo.Height * 4) + i * 4;
	*pt = r;
	*(pt+1) = g;
	*(pt+2) = b;
}



// ----------------------------------------------------------------
// ----------------------------------------------------------------
//					Animatin d'objet de texture
// ----------------------------------------------------------------
// ----------------------------------------------------------------

AnimTexture :: AnimTexture ()
{
}

AnimTexture :: ~AnimTexture ()
{
	// dtruire la liste de texture
	POSITION pos;
	int i,count;
	CTextureInfo	 * pTextInfo = NULL;

	count = TextureListe.GetCount ();
	for (i = 0; i< count;i++){
		pos = TextureListe.FindIndex (i);
		if (pos == NULL) continue;

		pTextInfo = (CTextureInfo *) TextureListe.GetAt (pos);
		if (pTextInfo == NULL) continue;

		delete pTextInfo;


	}
}

BOOL AnimTexture :: AddTexture (CString fileName)
{

	CTextureInfo	 * pTextInfo = NULL;
	pTextInfo = new CTextureInfo (fileName,TRUE);
	if (pTextInfo == NULL) return FALSE;

	TextureListe.AddTail (pTextInfo);
	return TRUE;
}

void AnimTexture :: DrawTexture (int no,GLfloat x,GLfloat y,GLfloat z,GLfloat width,GLfloat height) {

	POSITION pos;
	pos = TextureListe.FindIndex (no);
	if (pos == NULL) return;
	
	CTextureInfo	 * pTextInfo = NULL;
	pTextInfo = (CTextureInfo *)  TextureListe.GetAt (pos);

	if (pTextInfo == NULL) return;
	glEnable (GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,pTextInfo->GetID());

	glBegin (GL_QUADS);

		glTexCoord3f (0,0,0.5f);
		glVertex3f (x,y,z);
	
		glTexCoord3f (1,0,0.5f);
		glVertex3f (x+width,y,z);
	
		glTexCoord3f (1,1,0.5f);
		glVertex3f (x+width,y+height,z);
	
		glTexCoord3f (0,1,0.5f);
		glVertex3f (x,y+height,z);

	glEnd ();
	glDisable (GL_TEXTURE_2D);

}



// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Explosion
// ----------------------------------------------------------------
// ----------------------------------------------------------------

Explosion :: Explosion (Objet * objinit)
{

	mul =1;
	tabint = NULL;

	// Initialisation de l'objet de rfrence
	obj = objinit;

	// Cette fonction permet de crer la liste des animation
	// en polygonne compils
	CreateListeAnimation ();
	


}

Explosion :: ~Explosion ()
{
	if (tabint) free (tabint);

	// Dtruire les liste de cette explosion
	glDeleteLists (GetIdListe (0),obj->GetTextureCount ()+1);
}

void Explosion :: CreateListeAnimation ()
{
	int i,ntexture;
	int IdTexture;
	int IdListeCompile;
	ntexture = obj->GetTextureCount ();

	// Allocation d'un tableau de ntexture  int
	tabint = (int *) malloc (sizeof(int)*ntexture);

	
	for (i = 0; i < ntexture; i++) {
	
		// Prendre l'identifiabt de la texture
		IdTexture = obj->GetTextureId (i);
		if (IdTexture == -1) continue;

		// Crer une nouvelle liste de polygone compile
		// et ajouter l'identifiant rcuprer  la liste
		IdListeCompile = CreateList (IdTexture);

		// Copy de la valeur entiere dans la zone mmoire
		memcpy (tabint+i,&IdListeCompile,sizeof (int));

	}


}

int Explosion :: GetIdListe (int no)
{
	int IdListe;
	memcpy (&IdListe,tabint+no,sizeof (int));
	return IdListe;
}



// Cration d'une liste de polygone compils
int Explosion :: CreateList (int IdTexture){
	POINTASC *pt;
	FACETTE * pFacette;
	POINTASC *p1,*p2,*p3;
	int i,NbFacette;
	GLint lid;
	
	NbFacette = obj->GetNbFacette ();
	
	lid=glGenLists(1);
	glNewList(lid, GL_COMPILE);
	

/*
GL_NEVER 
GL_LESS 
GL_EQUAL 
GL_LEQUAL 
GL_GREATER 
GL_NOTEQUAL 
GL_GEQUAL 
GL_ALWAYS 
*/

	glAlphaFunc (GL_LESS,1); 
	glEnable (GL_ALPHA_TEST);



	
	/*
GL_ZERO
GL_ONE
GL_DST_COLOR
GL_ONE_MINUS_DST_COLOR
GL_SRC_ALPHA
GL_ONE_MINUS_SRC_ALPHA
GL_DST_ALPHA
GL_ONE_MINUS_DST_ALPHA
GL_SRC_ALPHA_SATURATE
*/

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
	glEnable(GL_BLEND); 

	for (i = 0; i < NbFacette; i ++){

		pFacette = obj->GetFacette (i);

		p1 = obj->GetPoint (pFacette->a);
		p2 = obj->GetPoint (pFacette->b);
		p3 = obj->GetPoint (pFacette->c);

		// Selectionner la texture qui va bien
		glBindTexture(GL_TEXTURE_2D,IdTexture);

		glBegin (GL_TRIANGLES);
		

		SetNormal (pFacette,1);
		pt = obj->GetTextCoord(pFacette->Tcoord [0]);
		if (pt) glTexCoord2f (pt->x,pt->y);
		glColor4f(1,1,1,0.95f);
		glVertex3f(p1->x*mul,p1->y*mul,p1->z*mul);

		SetNormal (pFacette,2);
		pt = obj->GetTextCoord(pFacette->Tcoord [1]);
		if (pt) glTexCoord2f (pt->x,pt->y);
		glColor4f(1,1,1,0.92f);
		glVertex3f(p2->x*mul,p2->y*mul,p2->z*mul);


		SetNormal (pFacette,3);
		pt = obj->GetTextCoord(pFacette->Tcoord [2]);
		if (pt) glTexCoord2f (pt->x,pt->y);
		glColor4f(1,1,1,0.90f);
		glVertex3f(p3->x*mul,p3->y*mul,p3->z*mul);

		glEnd();
	}

	glDisable(GL_BLEND); 
	glDisable(GL_ALPHA_TEST);

	glEndList();
	mul += 0.1f;
	return lid;
}

void Explosion ::  SetNormal (FACETTE * pFacette,int no)
{
	if (pFacette->norm == NULL) return;
	switch (no)
	{
	case 0:
	glNormal3f (pFacette->norm->nf.x,pFacette->norm->nf.y,pFacette->norm->nf.z);
		break;
	case 1:
	glNormal3f (pFacette->norm->p1.x,pFacette->norm->p1.y,pFacette->norm->p1.z);
		break;
	case 2:
	glNormal3f (pFacette->norm->p2.x,pFacette->norm->p2.y,pFacette->norm->p2.z);
		break;
	case 3:
	glNormal3f (pFacette->norm->p3.x,pFacette->norm->p3.y,pFacette->norm->p3.z);
		break;
	}
}

// Dessine une explosion
void Explosion :: DrawExplosion (int no,GLfloat matrice [16]){

	glPushMatrix();
	glMultMatrixf (matrice);
	DrawExplosion (no);
	glPopMatrix();
}

void Explosion :: DrawExplosion (int no){

	glEnable (GL_TEXTURE_2D);
	
	glCallList (GetIdListe (no));

	glDisable (GL_TEXTURE_2D);
}




// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Objet de camra
// ----------------------------------------------------------------
// ----------------------------------------------------------------

CCamera ::CCamera (GLfloat ax,GLfloat ay,GLfloat x,GLfloat y ,GLfloat z,GLfloat DistanceInit){
	
	// Coordones et vecteur d'orientation
	x = y = z = 0;
	dx = dy = dz = 0;

	// Distance de la cible
	Distance = DistanceInit;

	// Initialiser les angles de vue
	anx = ax;
	any = ay;
	
	// Poser la matrice  son identit
	MatObj.MatriceToIdentity (matref);
	
	// Faire pivoter la camra dans la position des angles d'initialisation
	SetOrientation (anx,any);
}

CCamera ::CCamera (){
	
	// Coordones et vecteur d'orientation
	x = y = z = 0;
	dx = dy = dz = 0;

	// Distance de la cible
	Distance = DISTANCE_CAMERA_MAX;

	// Initialiser les angles de vue
	anx = 45;
	any = -20;
	
	// Poser la matrice  son identit
	MatObj.MatriceToIdentity (matref);
	
	// Faire pivoter la camra dans la position des angles d'initialisation
	SetOrientation (anx,any);
}


CCamera ::~CCamera (){
}

POINTASC CCamera :: GetOrientation (){
	POINTASC Orientation;
	Orientation.x = dx;
	Orientation.y = dy;
	Orientation.z = dz;
	return Orientation;
}

void CCamera :: IncDistance (GLfloat inc,GLfloat ApprochMax){
	Distance += inc;
//	if (abs (Distance) < DISTANCE_CAMERA_MAX)
//		Distance = (Distance < 0) ? -DISTANCE_CAMERA_MAX : DISTANCE_CAMERA_MAX; 

/*
	if (abs (Distance) < ApprochMax)
		Distance = (Distance < 0) ? -ApprochMax : ApprochMax; 
		*/


	pt = MatObj.RotatePoint (matref,0,0,Distance);
	dx = pt.x;
	dy = pt.y;
	dz = pt.z;
}

void CCamera :: Rotate (GLfloat ax,GLfloat ay){
	anx += ax;
	
	if (anx > 89.9f) anx = 89.9f;
	else if (anx < -89.9f) anx = -89.9f;
	any += ay;

	MatObj.SetMatrice (matref,0,any,0);
	MatObj.SetMatrice (mattmp16,anx,0,0);
	MatObj.MulMatrice (matref,mattmp16);
	

	pt = MatObj.RotatePoint (matref,0,0,Distance);
	dx = pt.x;
	dy = pt.y;
	dz = pt.z;
}

// Cette mthode permet de fixer des angles d'oreintation
void CCamera :: SetOrientation (GLfloat anxinit,GLfloat anyinit){
	anx = anxinit;
	if (anx > 89.9f) anx = 89.9f;
	else if (anx < -89.9f) anx = -89.9f;
	any = anyinit;

	MatObj.SetMatrice (matref,0,any,0);
	MatObj.SetMatrice (mattmp16,anx,0,0);
	MatObj.MulMatrice (matref,mattmp16);
	

	pt = MatObj.RotatePoint (matref,0,0,Distance);
	dx = pt.x;
	dy = pt.y;
	dz = pt.z;
}

POINTASC CCamera :: GetPosition (){
	POINTASC pos;
	pos.x = x;
	pos.y = y;
	pos.z = z;
	return pos;
}

void CCamera :: SetPosition (int xinit,int yinit,int zinit){
	x = xinit;
	y = yinit;
	z = zinit;

	matref [11] = x;
	matref [12] = y;
	matref [13] = z;
}

void CCamera :: SetMatrice (GLfloat matriceinit [16]){
	MatObj.CopyMatrice (matriceinit,matref);

	pt = MatObj.RotatePoint (matref,0,0,Distance);
	dx = pt.x;
	dy = pt.y;
	dz = pt.z;

}






// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Objet de manipulation de matrice
// ----------------------------------------------------------------
// ----------------------------------------------------------------
CMatrice :: CMatrice ()
{
}
CMatrice :: ~CMatrice ()
{
}


void CMatrice :: MatriceToIdentity (GLfloat Mat [16])
{
	for (int i = 0; i < 16; i++) Mat [i] = (i%5) ? 0.0f : 1.0f;
}

void CMatrice :: SetMatrice (GLfloat Rot [16],GLfloat anx,GLfloat any,GLfloat anz)
{
/*
0	4	8	12
1	5	9	13
2	6	10	14
3	7	11	15
*/

	GLfloat siny = (float) sin (any*PIMUL);
	GLfloat cosy = (float) cos (any*PIMUL);
	GLfloat sinx = (float) sin (anx*PIMUL);
	GLfloat cosx = (float) cos (anx*PIMUL);
	GLfloat sinz = (float) sin (anz*PIMUL);
	GLfloat cosz = (float) cos (anz*PIMUL);

	Rot [0] =  cosz*cosy; 
	Rot [4] =  sinz*cosy; 
	Rot [8] = -siny;
	Rot [1] =  cosz*siny*sinx - sinz*cosx; 
	Rot [5] =  sinz*siny*sinx + cosx*cosz; 
	Rot [9] =  sinx*cosy;
	Rot [2] =  cosz*siny*cosx + sinz*sinx; 
	Rot [6] =  sinz*siny*cosx - cosz*sinx; 
	Rot [10] = cosx*cosy;
}




void CMatrice :: CopyMatrice (GLfloat RotSource [16],GLfloat RotDest [16])
{
	memcpy (RotDest,RotSource,sizeof (GLfloat)*16);
}

void CMatrice :: MulMatrice (GLfloat Rot [16],GLfloat M [16])
{

	int i;
	int col,rang;
	for (i = 0; i < 15; i++)
	{
		col = (i / 4) * 4;
		rang = i - col;
		T [i] = 0;

			T [i] += M [col+0] * Rot [rang+0*4];
			T [i] += M [col+1] * Rot [rang+1*4];
			T [i] += M [col+2] * Rot [rang+2*4];
			T [i] += M [col+3] * Rot [rang+3*4];

	}
	
	// Positionner l'homotcie  1
	T [15] = 1;
	
	// Recopier la matrice
	memcpy (Rot,T,sizeof (T));

}



POINTASC CMatrice :: RotatePoint (GLfloat mat [16],POINTASC pt)
{
	return RotatePoint (mat,pt.x,pt.y,pt.z);
}

POINTASC CMatrice :: RotatePoint (GLfloat mat [16],GLfloat x,GLfloat y,GLfloat z)
{
	pt.x = mat[0]* x + mat[4]* y + mat[8]* z;
	pt.y = mat[1]* x + mat[5]* y + mat[9]* z;
	pt.z = mat[2]* x + mat[6]* y + mat[10]* z;
	return pt;
}

/*
0	4	8	12
1	5	9	13
2	6	10	14
3	7	11	15
*/
void CMatrice :: Inverse (GLfloat mat [16])
{
}



// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Objet de lumire
// ----------------------------------------------------------------
// ----------------------------------------------------------------
CLight :: CLight () {
	
	
	// Rayon de la sphere de lumire
	radius = 20;

	// Initialisation par defaut de la position de la lumire
	Pos [0] = 0;
	Pos [1] = 0;
	Pos [2] = 0;
	Pos [3] = 0;

	// Initialisation du matriel
	SetAmbiant (0.1f, 0.1f, 0.1f, 1.0f);
	SetDiffuse (0.9f, 0.9f, 0.9f, 1.0f);
	SetSpecular (0.9f, 0.9f, 0.9f, 1.0f);
	SetEmission (1.0f,1.0f,1.0f,1.0f);
	SetShineness (15.0f);



	// Cration d'un objet 3D pour dessiner la lumire
	quadLight = gluNewQuadric ();
	gluQuadricNormals (quadLight,GLU_SMOOTH);

	// Par dfaut le numro de lumire est la numro Zro
	no = GL_LIGHT0;
}

CLight :: ~CLight () {
}

void CLight ::SetAmbiant (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha)
{
	mat.Ambient [0] = r;
	mat.Ambient [1] = g;
	mat.Ambient [2] = b;
	mat.Ambient [3] = alpha;
}

void CLight ::SetDiffuse (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha)
{
	mat.Diffuse [0] = r;
	mat.Diffuse [1] = g;
	mat.Diffuse [2] = b;
	mat.Diffuse [3] = alpha;}

void CLight ::SetSpecular (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha)
{
	mat.Specular [0] = r;
	mat.Specular [1] = g;
	mat.Specular [2] = b;
	mat.Specular [3] = alpha;}

void CLight ::SetEmission (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha)
{
	mat.Emission [0] = r;
	mat.Emission [1] = g;
	mat.Emission [2] = b;
	mat.Emission [3] = alpha;
}

void CLight :: SetPosition (GLfloat xinit,GLfloat yinit,GLfloat zinit){
	Pos [0] = xinit;
	Pos [1] = yinit;
	Pos [2] = zinit;
}

void CLight :: glSetPosition (GLfloat xinit,GLfloat yinit,GLfloat zinit){
	SetPosition (xinit,yinit,zinit);
	glLightfv (no,GL_POSITION,Pos);
}


/*
GL_CONSTANT_ATTENUATION 
GL_LINEAR_ATTENUATION 
GL_QUADRATIC_ATTENUATION 
*/
void CLight :: glDrawLight (){
	
	glPushMatrix();
	glTranslatef(Pos [0],Pos [1],Pos [2]);
	

	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);


	// Poser le matriel
	glMaterialfv (GL_FRONT,GL_AMBIENT, mat.Ambient);
	glMaterialfv (GL_FRONT,GL_DIFFUSE, mat.Diffuse);
	glMaterialfv (GL_FRONT,GL_SPECULAR,mat.Specular);
	glMaterialfv (GL_FRONT,GL_EMISSION,mat.Emission);
	glMaterialfv (GL_FRONT,GL_SHININESS,mat.Shineness);
	 



    glLightfv(no, GL_AMBIENT, mat.Ambient);
    glLightfv(no, GL_DIFFUSE, mat.Diffuse);
    glLightfv(no, GL_SPECULAR, mat.Specular);
    glLightfv(no, GL_EMISSION, mat.Emission);
	
	glLightfv (no,GL_POSITION,Pos);


	// Dessiner la sphere
	gluSphere (quadLight,radius,8,8);
	glPopMatrix();
}

void CLight :: Enable () {
	glEnable (no);
}

void CLight :: Disable (){
	glDisable (no);
}

// Fixer le numro de lumire GL_LIGHT0  GL_LIGHT7
void CLight :: SetNumLight (GLenum noinit){
	if (noinit < GL_LIGHT0) noinit = GL_LIGHT0;
	if (noinit > GL_LIGHT7) noinit = GL_LIGHT7;
	no = noinit;
}




// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Objet liste de texture
// ----------------------------------------------------------------
// ----------------------------------------------------------------
CTextureListe :: CTextureListe ()
{
}
CTextureListe :: ~CTextureListe ()
{
}
	
// Ajoute une texture
BOOL CTextureListe :: AddTexture (CString FileName)
{
	CTextureInfo * pTextureInfo;
	pTextureInfo = new CTextureInfo (FileName,TRUE);
	if (!pTextureInfo) return FALSE;
	Liste.AddTail (pTextureInfo);
	return TRUE;
}

// Renvoie une texture
CTextureInfo * CTextureListe :: GetTexture (int index)
{
	CTextureInfo * pTextureInfo;
	POSITION pos;
	// Liste.AddTail (pTextureInfo);
	pos = Liste.FindIndex (index);
	if (!pos) return NULL;
	pTextureInfo = (CTextureInfo *) Liste.GetAt (pos);
	return pTextureInfo;
}

// Supprime une texture de la liste
BOOL CTextureListe :: DeleteTexture (int index)
{
	CTextureInfo * pTextureInfo;
	POSITION pos;
	// Liste.AddTail (pTextureInfo);
	pos = Liste.FindIndex (index);
	if (!pos) return FALSE;
	pTextureInfo = (CTextureInfo *) Liste.GetAt (pos);
	delete pTextureInfo;
	Liste.RemoveAt (pos);
	return TRUE;
}





// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Objet de brouillard
// ----------------------------------------------------------------
// ----------------------------------------------------------------
CFog :: CFog ()
{
    for (int i = 0; i < 3; i++) FogColor[i] = 0.5;
	FogColor[3]	= 0.0f;
	FogDensity  = (float) (1/35000.0f);

	TypeFog	= GL_EXP2;
	FogStart	= 0;
	FogEnd		= 1;
}

CFog :: ~CFog ()
{
}


// Prend le FOG
void CFog :: GetFogColor (GLfloat FogColorToInit [4])
{
	memcpy (FogColorToInit,FogColor,4*sizeof (GLfloat));
}

// Prend le FOG
void CFog :: GetFogColor (GLfloat &R,GLfloat &G,GLfloat &B,GLfloat &Alpha)
{
	R		= FogColor [0];
	G		= FogColor [1];
	B		= FogColor [2];
	Alpha	= FogColor [3];
}

// Initialise le FOG
void CFog :: SetFogColor (GLfloat R,GLfloat G,GLfloat B,GLfloat Alpha)
{
	FogColor [0] = R;
	FogColor [1] = G;
	FogColor [2] = B;
	FogColor [3] = Alpha;
}

// Effectue le Fog
void CFog::MakeFog ()
{
	glClearColor(FogColor [0], FogColor [1], FogColor [2],FogColor [3]);
	glFogi(GL_FOG_MODE, TypeFog);
	glFogf(GL_FOG_DENSITY, FogDensity);
	glFogi (GL_FOG_START,FogStart);
	glFogi (GL_FOG_END,FogEnd);
    glFogfv(GL_FOG_COLOR,FogColor);
}


// Copie les attribu de ce fog dans un autre
void CFog :: CopyIn (CFog &cFog)
{
	cFog.SetTypeFog (TypeFog);
	cFog.SetFogStart (FogStart);
	cFog.SetFogEnd (FogEnd);
	cFog.SetDensity (FogDensity);
	cFog.SetFogColor (FogColor [0],FogColor [1],FogColor [2],FogColor [3]);
}




// ----------------------------------------------------------------
// ----------------------------------------------------------------
//	Objet de test alpha
// ----------------------------------------------------------------
// ----------------------------------------------------------------

CAlphaTest :: CAlphaTest ()
{
	Seuil = 0;
	Type = GL_ALWAYS;
	bEnable = FALSE;
}

CAlphaTest :: ~CAlphaTest ()
{
}


void CAlphaTest :: MakeAlphaTest ()
{
	glAlphaFunc (Type,Seuil);
}



// ------------------------------------------------
//	Classe LISTE DE VAISSEAU
// ------------------------------------------------
CListShip::CListShip (){
}

CListShip::~CListShip ()
{
	DestroyListe ();
}

	
BOOL CListShip::AddShip (CShip * pVais)
{
	if (!pVais) return FALSE;
	Liste.AddTail (pVais);
	return TRUE;
}


// Cette fonction dtruit toutes les allocation de mmoire
// sur un joueur.
BOOL CListShip::DestroyShip (int index)
{
	int indexcomp = 0;
	CShip * pShip;
	POSITION pos,prevpos;

	// Destruction des messages de la nouvelle file d'attente
	// qui tait en fait la liste des messages de dessinement.
	pos = Liste.GetHeadPosition ();
	
	// Parcourir la liste pour dtruire la mmoire alloue
	// pour chaque message
	while (pos){
		prevpos = pos;
		pShip = (CShip *) Liste.GetNext (pos);
		if (indexcomp == index) 
		{
			Liste.RemoveAt (prevpos);
			delete pShip;
			return TRUE;
		}
		indexcomp ++;
	}
	return FALSE;
}


// Cette fonction dtruit toutes les allocation de mmoire
// sur un joueur.
void CListShip::DestroyListe ()
{
	CShip * pShip;
	POSITION pos;

	// Destruction des messages de la nouvelle file d'attente
	// qui tait en fait la liste des messages de dessinement.
	pos = Liste.GetHeadPosition ();
	
	// Parcourir la liste pour dtruire la mmoire alloue
	// pour chaque message
	while (pos){
		pShip = (CShip *) Liste.GetNext (pos);
		if (pShip) delete pShip;
	}

	Liste.RemoveAll ();
}


// Prendre un joueur par index
CShip * CListShip::GetShip (int index)
{
	CShip * pShip = NULL;
	POSITION pos;

	// Destruction des messages de la nouvelle file d'attente
	// qui tait en fait la liste des messages de dessinement.
	pos = Liste.FindIndex (index);
	if (pos) pShip = (CShip *) Liste.GetAt (pos); 
	return pShip;
}







// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//		LA CLASSE MISSILE
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------

CMissile :: CMissile (GLfloat x,GLfloat y,GLfloat z,GLfloat dxinit,GLfloat dyinit,GLfloat dzinit,GLfloat mat [16])
{
	nbinc = 0;
	point.x = x;
	point.y = y;
	point.z = z;
	dx = dxinit;
	dy = dyinit;
	dz = dzinit;
	MatObj.CopyMatrice (mat,matref);
	matref [12] = x;
	matref [13] = y;
	matref [14] = z;
}

CMissile :: ~CMissile ()
{
}

void CMissile :: Deplace ()
{
	nbinc += 1;
	pointPrev = point;
	point.x += dx;
	point.y += dy;
	point.z += dz;
	matref [12] = point.x;
	matref [13] = point.y;
	matref [14] = point.z;
}


BOOL CMissile :: IsValid ()
{
	return (nbinc < MISSILE_NB_INC_MAX) ? TRUE : FALSE;
}

POINTASC CMissile :: GetDirection ()
{
	POINTASC dir;
	dir.x = dx;
	dir.y = dy;
	dir.z = dz;
	return dir;
	
}

// Pour le tir directionnel, cette mthode ne fait rien
void CMissile :: ResetCible (){
}





// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//							CLASSE TANK
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
CTank :: CTank (Objet * objinit) : CShip (objinit)
{
	// Initialisation par defaut des fichiers d'objet 3D
	FileNameCorps		= "C:\\USER\\TANK\\TANKCORPS.ASE";
	FileNameTourelle	= "C:\\USER\\TANK\\TANKTOURELLE.ASE";
	FileNameCannon		= "C:\\USER\\TANK\\TANKCANON.ASE";

	// Les objets supplmentaires sont initialis  NULL
	objTourelle = NULL;
	objCanon = NULL;

	// Initialisation des matrices des elements supplmentaire
	MatObj.MatriceToIdentity (matrefTourelle);
	MatObj.MatriceToIdentity (matrefCanon);

	// Angle des lements  0
	AngTourelle = 0;
	AngCanon = 0;


}


CTank :: ~CTank ()
{
	if (objTourelle != NULL) delete objTourelle;
	if (objCanon != NULL) delete objCanon;
}

void CTank :: RotateTourelle (float an)
{
	if (fabs (AngTourelle + an) > 145) return;
	AngTourelle += an;
	MatObj.SetMatrice (matrefTourelle,0,AngTourelle,0);
}

void CTank :: RotateCanon (float an)
{
	AngCanon += an;
	if (AngCanon < 0) AngCanon = 0;
	else if (AngCanon > 80) AngCanon = 80;
	MatObj.SetMatrice (matrefCanon,AngCanon,0,0);
}


void CTank :: Rot (GLfloat ax,GLfloat ay,GLfloat az)
{

	any += ay;
	MatObj.SetMatrice (mattmp16,0,ay,0);
	MatObj.MulMatrice (matref,mattmp16);


	SetDep ();

	matref [12] = x;
	matref [13] = y;
	matref [14] = z;
}


// Dessine le canon
void CTank :: Draw ()
{
	glColor4f (1,1,1,1);

	
	// Dessiner le corp
	glPushMatrix();
	glMultMatrixf (matref);
	glScalef (0.1f,0.1f,0.1f);
	glCallList (obj->noCallListe);

		// Dessiner la tourelle
		glPushMatrix();
		glMultMatrixf (matrefTourelle);
		glCallList (objTourelle->noCallListe);

			// Dessiner le canon
			glPushMatrix();
			glTranslatef(0,33,36);
			glMultMatrixf (matrefCanon);
			glCallList (objCanon->noCallListe);
		
			glPopMatrix();
		glPopMatrix();
	glPopMatrix();
}





// Classe d'objet qui renferme un bitmap et son objet texture
CTextBmp :: CTextBmp (TextureInfo * pTextInit,CBitmap * pBmpInit)
{
	pText = pTextInit;
	pBmp = pBmpInit;
	
	Niveau = -1;
	Numero = -1;

}

CTextBmp  :: ~CTextBmp ()
{
	if (pText != NULL) delete pText;
	if (pBmp != NULL) delete pBmp;
}




// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
//								TEXTURE CLASSE
// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------
TextureInfo :: TextureInfo(CString filename,BOOL bChargementNormal)
{
	CString str;
	
	
	// Par defaut la texture n'est pas charge
	TextInfo.pBit = NULL;

	// Par defaut bChargementNormal est  FALSE cela indique que l'on charge une texture
	// depuis un fichier ASE, sinon si la variable est TRUE alors on charge
	// depuis un chemin normal
	if (!bChargementNormal) FileName = filename.Mid(1,filename.GetLength()-3);
	else FileName = filename;

	IdTexture = TextureIdentification ++; 			

	// Chargement de la texture
	TextInfo.pBit = 0;
	if (!Load ()) {
		str.Format ("Texture : %s ERREUR CHARGEMENT",FileName);
		AfxMessageBox (str);
	}
}

TextureInfo :: TextureInfo(int Cx,int Cy)
{
	TextInfo.Width = Cx;
	TextInfo.Height = Cy;
	TextInfo.pBit = (unsigned char *) malloc(TextInfo.Width * TextInfo.Height * NBYTE);
	memset (TextInfo.pBit,0,TextInfo.Width * TextInfo.Height * NBYTE);
}


TextureInfo :: ~TextureInfo()
{
	// Librer la memoire alloue
	if (TextInfo.pBit != NULL) free (TextInfo.pBit);
}

void TextureInfo :: GetRgb (int i,int j,BYTE &r,BYTE &g,BYTE &b)
{
	BYTE * pt;
	if (i < 0) i = 0;
	else if (i >= TextInfo.Width) i = TextInfo.Width-1;
	if (j < 0) j = 0;
	else if (j >= TextInfo.Height) j = TextInfo.Height-1;
	pt = TextInfo.pBit + (j * TextInfo.Width * NBYTE) + i * NBYTE;
	r = *pt;
	g = *(pt+1);
	b = *(pt+2);
}

void TextureInfo :: SetRgb (int i,int j,BYTE r,BYTE g,BYTE b)
{
	BYTE * pt;
	pt = TextInfo.pBit + (j * TextInfo.Width * NBYTE) + i * NBYTE;
	*pt		= r;
	*(pt+1) = g;
	*(pt+2) = b;
}


BOOL TextureInfo :: Load ()
{
	FILE * File;
	BITMAPFILEHEADER FileHeader;
	BITMAPINFOHEADER InfoHeader;
	DWORD Type;
	RGBTRIPLE rgb;
	int i, j, o=0;


	// open filename for reading
	File = fopen(FileName, "rb");
	if (!File) return FALSE;

	// read the header and type, then seek to the next position
	fread(&FileHeader, sizeof(FileHeader), 1, File);
	fread(&Type, sizeof(Type), 1, File);
	fseek(File, sizeof(FileHeader), SEEK_SET);

	// read the infoheader
	fread(&InfoHeader, sizeof(InfoHeader), 1, File);


	// set our texture width and height from what is read in the file
	TextInfo.Width = InfoHeader.biWidth;
	TextInfo.Height = InfoHeader.biHeight;


	// allocate enough memory to store the bitmap, then fill the memory with zeros
	// this size is width * height * 4
	// 4 means 1 byte for red, green, blue, and alpha
	TextInfo.pBit = (unsigned char *) malloc(TextInfo.Width * TextInfo.Height * NBYTE);
	if (TextInfo.pBit == NULL) 
	{
		fclose (File);
		return FALSE;
	}
	
	memset(TextInfo.pBit, 0, TextInfo.Width * TextInfo.Height * NBYTE);
	


	o = (TextInfo.Width * TextInfo.Height * NBYTE) - 1;
	// loop through loading pixel by pixel
	for (j=0; j < InfoHeader.biHeight; j++) {

		for (i=0; i < InfoHeader.biWidth; i++) {

			// load the r g and b values from the file into an RGBTRIPLE structure
			fread(&rgb, sizeof(rgb), 1, File);

			switch (NBYTE)
			{
			case 3:
				TextInfo.pBit[o-2] = rgb.rgbtBlue;
				TextInfo.pBit[o-1] = rgb.rgbtGreen;
				TextInfo.pBit[o] = rgb.rgbtRed;
			break;
			case 4:
				TextInfo.pBit[o-3] = rgb.rgbtBlue;
				TextInfo.pBit[o-2] = rgb.rgbtGreen;
				TextInfo.pBit[o-1] = rgb.rgbtRed;
				// ALPHATEST
				TextInfo.pBit[o] = 255;
				break;
			}

			
			o -= NBYTE;


		}
	}

	fclose(File);

	return TRUE;
}


BOOL TextureInfo :: SetBit (BYTE * pBitSet)
{
	int SizeToCopy;
	if (pBitSet == NULL) return FALSE;
	SizeToCopy = TextInfo.Width * TextInfo.Height * NBYTE;
	memcpy (TextInfo.pBit,pBitSet,SizeToCopy);
	return TRUE;
}

BOOL TextureInfo :: CreateBitmap (CBitmap &Bmp)
{
	Bmp.DeleteObject ();
	return Bmp.CreateBitmap (TextInfo.Width,TextInfo.Height,1,NBIT,GetBit ());
}

BOOL TextureInfo :: CreateBitmap (CBitmap * pBmp)
{
	if (pBmp == NULL) return FALSE;
	pBmp->DeleteObject ();
	return pBmp->CreateBitmap (TextInfo.Width,TextInfo.Height,1,NBIT,GetBit ());
}


// Tourner au niveau de gris
void TextureInfo :: GreyLevel ()
{
	BYTE r,g,b;
	float Moy;
	int i,j;

	for (i = 0; i < TextInfo.Width; i++)
	for (j = 0; j < TextInfo.Height; j++)
	{
		GetRgb (i,j,r,g,b);
		Moy = ((float) (r+g+b)) / 3;
		SetRgb (i,j,(BYTE) Moy,(BYTE) Moy,(BYTE) Moy);
	}
}





