// OpenglView.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "OpenglView.h"
#include "MakeTerrainDoc.h"
#include "TerrainType.h"
#include "resource.h"
#include "DlgArrondissement.h"
#include "math.h"
#include "DlgFog.h"
#include "DlgInfoTriangle.h"
#include "Glext.h"

CMakeTerrainDoc * pDoc;
int icam = NPOINT / 2;
int jcam = NPOINT / 2;
Objet * pObjMissil;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Liste des dfinitions
#define MULSOURIS			100
#define NIVEAU_SQUARE		1
#define NIVEAU_GRILLE		2
#define NIVEAU_PLAN			3


// Liste des variables globales
int NCHUNK				= 64;
extern COpenglView * pOpenGlView;
extern int CoefHauteur;
extern int CoefZoom;
extern int CoefDep;
extern int CoefRotate;
extern int Manip;
extern CMakeTerrainApp theApp;
extern int TerrainAffichageType;
extern int TypePlaquage;
extern CListShip ShipList;
extern CMatrice MatObj;

extern int DessinIdTexture;
extern int DetailIdTexture;


PFNGLACTIVETEXTUREARBPROC		glActiveTextureARB			= 0;
PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2fARB		= 0;
PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureARB	= 0;


BOOL bFog = FALSE;
BOOL bLight = TRUE;
BOOL bAction = FALSE;
BOOL bFilaire = FALSE;
BOOL bMateriel = FALSE;




float grad = (float) (1.0/256.0);

float UCText = 1;

MATERIEL matLight;
MATERIEL matMat;

GLfloat Pos [4];
GLUquadricObj * quadObjLight;

BOOL bSmooth = FALSE;
BOOL bRender = FALSE;
BOOL bPivotCam = FALSE;
BOOL bTexture = FALSE;

CPoint ptMemShip;

CObList MissilList;



CCamera cam;		// Camra autour du vaisseau
CTextureListe TextureListe;


Objet * pObjWorld = NULL;

CShip * pVaisSelected = NULL;

CString StrGlobal;
/////////////////////////////////////////////////////////////////////////////
// COpenglView

IMPLEMENT_DYNCREATE(COpenglView, CView)

COpenglView::COpenglView()
{
	m_pDC = NULL;
	m_pOldPalette = NULL;

	quadObjLight = gluNewQuadric ();
	gluQuadricNormals (quadObjLight,GLU_SMOOTH);

	// Les variables boolennes
	bShift = FALSE;
	bCtrl = FALSE;

	// Angle de rotation de la vue hors camra
	wAngleY = 0.0f;
	wAngleX = 45;
	wAngleZ = 0.0f;


	// Translation de la scne hors camra
	xt	= 0.0f;
	yt	= -500;
	zt	= -500;
	Translate = 5.0f;

	cote = 100000;

	quadObjLight = gluNewQuadric ();
	gluQuadricNormals (quadObjLight,GLU_SMOOTH);


	matMat.Ambient [0] = 0;
	matMat.Ambient [1] = 0;
	matMat.Ambient [2] = 0;
	matMat.Ambient [3] = 1;

	matMat.Diffuse [0] = 0;
	matMat.Diffuse [1] = 0;
	matMat.Diffuse [2] = 0;
	matMat.Diffuse [3] = 1;

	matMat.Specular [0] = 1;
	matMat.Specular [1] = 1;
	matMat.Specular [2] = 0.5;
	matMat.Specular [3] = 1;


	matMat.Emission [0] = 0.1f;
	matMat.Emission [1] = 0.1f;
	matMat.Emission [2] = 0.1f;
	matMat.Emission [3] = 1;

	matMat.Shineness [0] = 1;



	matLight.Ambient [0] = 1;
	matLight.Ambient [1] = 1;
	matLight.Ambient [2] = 1;
	matLight.Ambient [3] = 1;

	matLight.Diffuse [0] = 1;
	matLight.Diffuse [1] = 1;
	matLight.Diffuse [2] = 1;
	matLight.Diffuse [3] = 1;

	matLight.Specular [0] = 1;
	matLight.Specular [1] = 1;
	matLight.Specular [2] = 1;
	matLight.Specular [3] = 1;


	matLight.Emission [0] = 0.1f;
	matLight.Emission [1] = 0.1f;
	matLight.Emission [2] = 0.1f;
	matLight.Emission [3] = 1;

	matLight.Shineness [0] = 1;

	bDraw = FALSE;

	NiveauType = NIVEAU_SQUARE;


	pCam.x = 0;
	pCam.y = 0;
	pCam.z = 0;

	SelectedShipIndex = 0;


}

COpenglView::~COpenglView()
{
}


BEGIN_MESSAGE_MAP(COpenglView, CView)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(COpenglView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_NIVEAU_GRILLE, OnNiveauGrille)
	ON_COMMAND(ID_NIVEAU_PLAN, OnNiveauPlan)
	ON_COMMAND(ID_NIVEAU_SQUARE, OnNiveauSquare)
	ON_COMMAND(ID_CONFIG_TERRAIN, OnConfigTerrain)
	ON_COMMAND(ID_RENDER, OnRender)
	ON_UPDATE_COMMAND_UI(ID_RENDER, OnUpdateRender)
	ON_WM_TIMER()
	ON_COMMAND(ID_LUMIERE_RAZ, OnLumiereRaz)
	ON_UPDATE_COMMAND_UI(ID_CALCUL_PENTE, OnUpdateCalculPente)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenglView drawing

// Dessine la lumiere
void COpenglView::DrawLight ()
{
	if (!bLight)
	{
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
		return;
	}

	glEnable (GL_LIGHTING);
	glEnable (GL_LIGHT0);
	

	// Dessiner la sphere
	glPushMatrix();
	glTranslatef(Pos [0],Pos [1],Pos [2]);
	

	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER, TRUE);
	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);


	// Poser le matriel
	if (bMateriel)
	{
		glMaterialfv (GL_FRONT,GL_AMBIENT, matMat.Ambient);
		glMaterialfv (GL_FRONT,GL_DIFFUSE, matMat.Diffuse);
		glMaterialfv (GL_FRONT,GL_SPECULAR,matMat.Specular);
		glMaterialfv (GL_FRONT,GL_EMISSION,matMat.Emission);
		glMaterialfv (GL_FRONT,GL_SHININESS,matMat.Shineness);
	}


    glLightfv(GL_LIGHT0, GL_AMBIENT, matLight.Ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, matLight.Diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, matLight.Specular);
    glLightfv(GL_LIGHT0, GL_EMISSION, matLight.Emission);
	
	glLightfv (GL_LIGHT0,GL_POSITION,Pos);

	// Dessiner la sphere
	gluSphere (quadObjLight,200,8,8);
	glPopMatrix();
}




void COpenglView::OnDraw(CDC* pDC)
{
	if (pDoc == NULL || bDraw) return;
	bDraw = TRUE;
	// TODO: add draw code here

    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


	glEnable (GL_CULL_FACE);

	glPushMatrix();

	if (!bPivotCam) 
	{
		glTranslatef(xt,yt,zt);
		glRotatef(wAngleX, 1.0f, 0.0f, 0.0f);
		glRotatef(wAngleY, 0.0f, 1.0f, 0.0f);
		glRotatef(wAngleZ, 0.0f, 0.0f, 1.0f);

	}
	else
	if (pVaisSelected)
		Camera (pVaisSelected->x,pVaisSelected->y,pVaisSelected->z,
				pVaisSelected->x,pVaisSelected->y,pVaisSelected->z);

	// Autoris le fog si l'utilisateur l'a demand
	if (bFog) glEnable (GL_FOG);

	// Dessiner la lumiere
	DrawLight ();


	// Dessiner le terrain
	if (bFog) glEnable (GL_FOG);
	if (bLight)
	{
		glEnable (GL_LIGHTING);
		glEnable (GL_LIGHT0);
	}

	glEnable (GL_CULL_FACE);
	
	DrawTerrain ();

	DrawMissil ();
	DrawAllShip ();


	glDisable (GL_BLEND);
	glDisable (GL_FOG);
	glDisable (GL_LIGHTING);
	glDisable (GL_LIGHT0);
	glDisable (GL_CULL_FACE);
	glDisable (GL_TEXTURE_2D);


	

	DrawNiveau ();
	DrawGraduation ();
	DrawCurPoint ();

//	DrawSky ();
	// Dessiner le ciel
	glDisable (GL_FOG);
	glDisable (GL_LIGHTING);
	glDisable (GL_LIGHT0);
	glEnable (GL_CULL_FACE);
	if (pObjWorld) DrawSpheriqueWorld ();

	glPopMatrix();
    glFinish();
	SwapBuffers(wglGetCurrentDC());
	bDraw = FALSE;
}

void COpenglView::DrawMissilBilboard(CMissile * pMissil)
{
	float x,y,z;
	float mview [16];

	glPushMatrix();
	glTranslatef(pMissil->point.x,pMissil->point.y,pMissil->point.z);

	glGetFloatv(GL_MODELVIEW_MATRIX,mview);
	x = mview [12];
	y = mview [13];
	z = mview [14];

	MatObj.MatriceToIdentity (mview);
	mview [12] = x;
	mview [13] = y;
	mview [14] = z;

	glLoadMatrixf(mview);

//	glColor4f (1,1,1,1);
	glCallList (pObjMissil->noCallListe);
	glPopMatrix();
}

// Cette mthode dessine tous les ship
void COpenglView :: DrawAllShip ()
{
	CShip * pVais;
	int count,i;

	
	count = ShipList.GetCount ();
	for (i = 0; i < count ; i++)
	{
		glEnable (GL_TEXTURE_2D);
		if (bFog) glEnable  (GL_FOG);
		if (bLight) 
		{
			glEnable (GL_LIGHTING);
			glEnable (GL_LIGHT0);
		}
		glEnable (GL_CULL_FACE);

		pVais = ShipList.GetShip (i);
		if (pVais)
		{
		
			// Dessine le tank
			pVais->Draw ();


	
			glDisable (GL_BLEND);
			glDisable (GL_FOG);
			glDisable (GL_LIGHTING);
			glDisable (GL_LIGHT0);
			glDisable (GL_CULL_FACE);
			glDisable (GL_TEXTURE_2D);

		
			DrawTriangleVehicule (pVais);
		}
	}

}

// Dessine les missiles
void COpenglView ::DrawMissil ()
{
	CMissile * pMissil;
	POSITION prevpos,pos;
	// Prendre la premire position de joueur
	pos = MissilList.GetHeadPosition ();

	glEnable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
	glEnable(GL_BLEND);
	glDisable (GL_LIGHTING);
	glDisable (GL_LIGHT0);
	glColor4f (1,1,1,1);

	
	while (pos)
	{
		prevpos = pos;
		pMissil = (CMissile *) MissilList.GetNext (pos);

		if (!pMissil) continue;

		if (!pMissil->IsValid ())
		{
			delete pMissil;
			MissilList.RemoveAt (prevpos);
			continue;
		}

		DrawMissilBilboard (pMissil);

		// Deplace le missil
		pMissil->Deplace ();
	}

	glDisable (GL_BLEND);
	if (bLight)
	{
		glEnable (GL_LIGHTING);
		glEnable (GL_LIGHT0);
	}

	if (bTexture) glDisable (GL_TEXTURE_2D);
}

void COpenglView :: DrawTriangleVehicule (CShip * pVais)
{
	POINTASC_TERRE *p1,*p2,*p3;
	FACETTE_TERRE * pFacette;

	pFacette = pDoc->GetFacette (pVais->GetIndexFacette ());
	if (!pFacette) return;

	p1 = pDoc->GetPoint (pFacette->a.i,pFacette->a.j);
	p2 = pDoc->GetPoint (pFacette->b.i,pFacette->b.j);
	p3 = pDoc->GetPoint (pFacette->c.i,pFacette->c.j);

	
	glBegin (GL_LINE_LOOP);
		glColor3f (0,0,1);
		glVertex3f (p1->x,p1->y+10,p1->z);
		glVertex3f (p2->x,p2->y+10,p2->z);
		glVertex3f (p3->x,p3->y+10,p3->z);
	glEnd ();


	glPointSize (2);
	glBegin (GL_POINTS);
		glColor3f (1,0,0);
		glVertex3f (p1->x,p1->y+10,p1->z);
		glColor3f (0,1,0);
		glVertex3f (p2->x,p2->y+10,p2->z);
		glColor3f (0,0,1);
		glVertex3f (p3->x,p3->y+10,p3->z);
	glEnd ();
	glPointSize (1);


}





/////////////////////////////////////////////////////////////////////////////
// COpenglView diagnostics

#ifdef _DEBUG
void COpenglView::AssertValid() const
{
	CView::AssertValid();
}

void COpenglView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMakeTerrainDoc* COpenglView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMakeTerrainDoc)));
	return (CMakeTerrainDoc*)m_pDocument;
}
#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
// COpenglView message handlers

void COpenglView::InitGl()
{
    PIXELFORMATDESCRIPTOR pfd;
    int         n;
	GLfloat		fMaxObjSize, fAspect;
	GLfloat		fNearPlane, fFarPlane;

    m_pDC = new CClientDC(this);

    ASSERT(m_pDC != NULL);

    if (!bSetupPixelFormat())
        return;

    n = ::GetPixelFormat(m_pDC->GetSafeHdc());
    ::DescribePixelFormat(m_pDC->GetSafeHdc(), n, sizeof(pfd), &pfd);


    hrc = wglCreateContext(m_pDC->GetSafeHdc());
    wglMakeCurrent(m_pDC->GetSafeHdc(), hrc);

    GetClientRect(&m_oldRect);
    glClearDepth(1.0f);
    glEnable(GL_DEPTH_TEST);


	if (m_oldRect.bottom)
		fAspect = (GLfloat)m_oldRect.right/m_oldRect.bottom;
	else	// don't divide by zero, not that we should ever run into that...
		fAspect = 1.0f;
	fNearPlane = 3.0f;
	fFarPlane = 7.0f;
	fMaxObjSize = 3.0f;
	m_fRadius = fNearPlane + fMaxObjSize / 2.0f;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90.0f, fAspect, fNearPlane, fFarPlane);
    glMatrixMode(GL_MODELVIEW);




    // Autoris le FOG
	cFog.MakeFog ();
	glEnable(GL_FOG);

	// Ne pas dessiner les faces caches
	glCullFace (GL_BACK);
	glEnable (GL_CULL_FACE);
	

	// Gnrateur alatoire
	srand( (unsigned)time( NULL ) );
}


int COpenglView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	InitGl();	// initialize OpenGL

	pOpenGlView = this;

	return 0;
}




void COpenglView::OnDestroy() 
{
	HGLRC	hrc;

	KillTimer(1);

	hrc = ::wglGetCurrentContext();

    ::wglMakeCurrent(NULL,  NULL);

    if (hrc)
        ::wglDeleteContext(hrc);

    if (m_pOldPalette)
        m_pDC->SelectPalette(m_pOldPalette, FALSE);

    if (m_pDC) delete m_pDC;


	CView::OnDestroy();
}

void COpenglView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
    if(cy > 0)
    {    
        glViewport(0, 0, cx, cy);

        if((m_oldRect.right > cx) || (m_oldRect.bottom > cy))
            RedrawWindow();

        m_oldRect.right = cx;
        m_oldRect.bottom = cy;

        glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(90.0f, (GLdouble)cx/cy, 1.0f, 1000000);
		glMatrixMode(GL_MODELVIEW);
    }

}

BOOL COpenglView::bSetupPixelFormat()
{
    static PIXELFORMATDESCRIPTOR pfd = 
	{
        sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
        1,                              // version number
			PFD_DRAW_TO_WINDOW |            // support window
			PFD_GENERIC_ACCELERATED |
			PFD_SUPPORT_OPENGL |          // support OpenGL
			PFD_DOUBLEBUFFER,             // double buffered
        PFD_TYPE_RGBA,                  // RGBA type
        24,                             // 24-bit color depth
        0, 0, 0, 0, 0, 0,               // color bits ignored
        0,                              // no alpha buffer
        0,                              // shift bit ignored
        0,                              // no accumulation buffer
        0, 0, 0, 0,                     // accum bits ignored
        32,                             // 32-bit z-buffer
        0,                              // no stencil buffer
        0,                              // no auxiliary buffer
        PFD_MAIN_PLANE,                 // main layer
        0,                              // reserved
        0, 0, 0                         // layer masks ignored
    };
    int pixelformat;

    if ( (pixelformat = ChoosePixelFormat(m_pDC->GetSafeHdc(), &pfd)) == 0 )
    {
        MessageBox("ChoosePixelFormat failed");
        return FALSE;
    }

    if (SetPixelFormat(m_pDC->GetSafeHdc(), pixelformat, &pfd) == FALSE)
    {
        MessageBox("SetPixelFormat failed");
        return FALSE;
    }

    return TRUE;
}



BOOL COpenglView::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);
    cs.lpszClass = AfxRegisterWndClass(CS_OWNDC);
	return CView::PreCreateWindow(cs);
}





void COpenglView::OnMouseMove(UINT nFlags, CPoint point) 
{

	GLfloat incax,incay;
	incax = incay = 0;

	if (bPivotCam && Manip == MANIP_SHIP)
	{
		if (bShift)
		{
			if (nFlags & MK_LBUTTON)
			{
				if (ptMouseMem.x < point.x) incay = (float) point.x - ptMouseMem.x;
				else incay = (float) -(ptMouseMem.x - point.x);

				if (ptMouseMem.y < point.y) incax = (float) -( ptMouseMem.y - point.y);
				else incax = (float) point.y - ptMemShip.y;
				
				cam.Rotate (incax,incay);
			}

			if (pVaisSelected && nFlags & MK_RBUTTON)
			{
				GLfloat inc = 0;	
				if (ptMouseMem.y < point.y) inc = (float) CoefZoom * (point.y - ptMouseMem.y);
				else inc =(float) -CoefZoom * (ptMouseMem.y - point.y);

				// Incrmente la distance de vision de la camra
				cam.IncDistance (inc,pVaisSelected->GetRayon());
			}
		}
	}

	switch (Manip)
		{
			case MANIP_SHIP:
			MoveShip (nFlags,point);
			break;
			
			case MANIP_ROTATION:
				if (nFlags & MK_LBUTTON)
				{
					if (ptMouseMem.x < point.x)
						wAngleY += 1.0f * (point.x - ptMouseMem.x) / CoefRotate;
					else
						wAngleY -= 1.0f * (ptMouseMem.x - point.x) / CoefRotate;

					if (ptMouseMem.y < point.y)
			
						wAngleX -= 1.0f * (ptMouseMem.y - point.y) / CoefRotate;
					else
						wAngleX += 1.0f * (point.y - ptMouseMem.y) / CoefRotate;
				}
			break;

			case MANIP_ZOOM:
			if (nFlags & MK_LBUTTON)
			{
				if (ptMouseMem.y < point.y)
				zt -= Translate * (point.y - ptMouseMem.y) * CoefZoom;
				else
				zt += Translate * (ptMouseMem.y - point.y) * CoefZoom;
			}
			break;



			case MANIP_MOVE:
			if (nFlags & MK_LBUTTON)
			{
				if (ptMouseMem.x < point.x) xt -= (ptMouseMem.x - point.x) * CoefDep;
				else						xt += (point.x - ptMouseMem.x) * CoefDep;

				if (ptMouseMem.y < point.y)	yt += (ptMouseMem.y - point.y) * CoefDep;
				else						yt -= (point.y - ptMouseMem.y) * CoefDep;
			}
			break;

			case MANIP_MOVE_LUMIERE_XZ:
			if (nFlags & MK_LBUTTON)
			{
				if (ptMouseMem.x < point.x) Pos [0] += CoefDep * (point.x - ptMouseMem.x);
				else						Pos [0] -= CoefDep * (ptMouseMem.x - point.x);

				if (ptMouseMem.y < point.y)	Pos [2] += CoefDep * (ptMouseMem.y - point.y);
				else						Pos [2] -= CoefDep * (point.y - ptMouseMem.y);


			}
			break;

			case MANIP_MOVE_LUMIERE_Y:
			if (nFlags & MK_LBUTTON)
			{
				if (ptMouseMem.x < point.x) Pos [1] += CoefDep * (point.x - ptMouseMem.x);
				else						Pos [1] -= CoefDep * (ptMouseMem.x - point.x);
			}
			break;

		}

	// mmoriser les  points actuels pour
	// les effets de zoom et de rotation et compagnie
	ptMouseMem = point;


	CView::OnMouseMove(nFlags, point);
}











void COpenglView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	switch (nChar)
	{
		case VK_SHIFT:bShift = FALSE;break;
		case 'R':if (pVaisSelected) pVaisSelected->Raz ();
			break;


	}

	CView::OnKeyUp(nChar, nRepCnt, nFlags);
}

void COpenglView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
		switch (nChar)
		{
			case VK_SHIFT:bShift = TRUE;break;
			case VK_SPACE:
			if (pVaisSelected) 	
			{
   				pVaisSelected->Deplace ();
				SetShipY (pVaisSelected);
				TranslateObjet (pVaisSelected);

			}
			break;

			case 'S':GetSelectedShip (SHIP_NEXT);break;
			case 'P':GetSelectedShip (SHIP_PREV);break;
	
			case VK_SUBTRACT:
			if (pVaisSelected) 
			{
				pVaisSelected->vitesse --;
				TranslateObjet (pVaisSelected);
			}
			break;
		
			case VK_ADD: 
			if (pVaisSelected)
			{
				pVaisSelected->vitesse ++;
				TranslateObjet (pVaisSelected);
			}
			break;

			case VK_DIVIDE:
			if (pVaisSelected)
			{
				pVaisSelected->vitesse /= 2;
				TranslateObjet (pVaisSelected);
			}
				break;
			case VK_MULTIPLY:
			if (pVaisSelected)
			{
				pVaisSelected->vitesse *= 2;
				TranslateObjet (pVaisSelected);
			}
				break;
//			case 'F':NewMissil ();break;

			case 'A':pVaisSelected->RotateTourelle (2);break;
			case 'Z':pVaisSelected->RotateTourelle (-2);break;
			case 'Q':pVaisSelected->RotateCanon (2);break;
			case 'W':pVaisSelected->RotateCanon  (-2);break;

		}

	
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void COpenglView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();


	glActiveTextureARB = (PFNGLCLIENTACTIVETEXTUREARBPROC) wglGetProcAddress("glActiveTextureARB");
	glMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC) wglGetProcAddress("glMultiTexCoord2fARB");
	glClientActiveTextureARB = (PFNGLACTIVETEXTUREARBPROC) wglGetProcAddress("glClientActiveTextureARB");
	
	// Charger le missil
//	pObjMissil = pDoc->ChargerASEFile ("weapon.ASE");

	pDoc = GetDocument();
	cote = pDoc->Largeur * pDoc->GetTotalPoint () * 2;
	yt	= - pDoc->Hauteur;
	zt = - pDoc->GetTotalPoint () * pDoc->GetLargeur ();

	NbCaseScale = pDoc->GetTotalPoint () - 1;
//	NbCaseScale /= NPOINT;
	NbCaseScale = NPOINT;
//	NbCaseScale = 1;

	OnLumiereRaz ();
}


void COpenglView::OnContextMenu(CWnd*, CPoint point)
{

	if (Manip == MANIP_SHIP) return;

	// CG: This block was added by the Pop-up Menu component
	{
		if (point.x == -1 && point.y == -1){
			//keystroke invocation
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_OPENGL_VIEW));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}



// Dessine le terrain
void COpenglView :: DrawTerrain ()
{
	int no;
	FACETTE_TERRE * pFace;

	POINTASC_TERRE * pt1;
	POINTASC_TERRE * pt2;
	POINTASC_TERRE * pt3;
	
	int noidep,noifin;
	int nojdep,nojfin;

	int i,j;
	int idep,ifin;
	int jdep,jfin;
	int NbPoint;

	NbPoint = pDoc->GetTotalPoint ();

	
	idep = icam - NCHUNK;	
	ifin = icam + NCHUNK;	
	
	jdep = jcam - NCHUNK;	
	jfin = jcam + NCHUNK;	


	if (idep < 0) idep = 0;
	if (idep >= NbPoint-2) idep = NbPoint-2;
	if (ifin < 0) ifin = 0;
	if (ifin >= NbPoint-2) ifin = NbPoint-2;

	if (jdep < 0) jdep = 0;
	if (jdep >= NbPoint-2) jdep = NbPoint-2;
	if (jfin < 0) jfin = 0;
	if (jfin >= NbPoint-2) jfin = NbPoint-2;

	int Case;
	int iFacette;
	int NbCase;
	NbCase = NbPoint - 1;

	POINTASC ptNormal;

	if (DessinIdTexture != -1)
	{
		glActiveTextureARB(GL_TEXTURE0_ARB); 
		glBindTexture(GL_TEXTURE_2D, DessinIdTexture); 
		glEnable(GL_TEXTURE_2D); 
		// GL_MODULATE, GL_DECAL, or GL_BLEND
//		glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	}


	if (DetailIdTexture != -1)
	{
		glActiveTextureARB(GL_TEXTURE1_ARB); 
		glBindTexture(GL_TEXTURE_2D, DetailIdTexture); 
		glEnable(GL_TEXTURE_2D);
		// GL_MODULATE, GL_DECAL, or GL_BLEND
//		glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	}

	glColor4f (1,1,1,1);

	switch (TerrainAffichageType)
	{
		case TERRAIN_AFFICHAGE_FIL_DE_FER:glBegin (GL_LINE_LOOP);
		for (i = idep; i <= ifin; i++ )
		for (j = jdep; j <= jfin; j++ )
		{
			Case = (j * NbCase) + i;
			iFacette = Case * 2;

			pFace = pDoc->GetFacette (iFacette);

			pt1 = pDoc->GetPoint (pFace->a.i,pFace->a.j);
			pt2 = pDoc->GetPoint (pFace->b.i,pFace->b.j);
			pt3 = pDoc->GetPoint (pFace->c.i,pFace->c.j);
			glBegin (GL_LINE_LOOP);
			DrawTriangle (iFacette,pFace,pt1,pt2,pt3);
			glEnd ();

			iFacette ++;

			pFace = pDoc->GetFacette (iFacette);
			if (!pFace) continue;
			pt1 = pDoc->GetPoint (pFace->a.i,pFace->a.j);
			pt2 = pDoc->GetPoint (pFace->b.i,pFace->b.j);
			pt3 = pDoc->GetPoint (pFace->c.i,pFace->c.j);
			glBegin (GL_LINE_LOOP);
			DrawTriangle (iFacette,pFace,pt1,pt2,pt3);
			glEnd ();
		}
		break;

		case TERRAIN_AFFICHAGE_FACETTE:glBegin (GL_TRIANGLES);
		case TERRAIN_AFFICHAGE_POINT:glBegin (GL_POINTS);
		for (i = idep; i <= ifin; i++ )
		for (j = jdep; j <= jfin; j++ )
		{
			Case = (j * NbCase) + i;
			iFacette = Case * 2;

			pFace = pDoc->GetFacette (iFacette);

			pt1 = pDoc->GetPoint (pFace->a.i,pFace->a.j);
			pt2 = pDoc->GetPoint (pFace->b.i,pFace->b.j);
			pt3 = pDoc->GetPoint (pFace->c.i,pFace->c.j);
	

			DrawTriangle (iFacette,pFace,pt1,pt2,pt3);

			iFacette ++;

			pFace = pDoc->GetFacette (iFacette);
			if (!pFace) continue;


			pt1 = pDoc->GetPoint (pFace->a.i,pFace->a.j);
			pt2 = pDoc->GetPoint (pFace->b.i,pFace->b.j);
			pt3 = pDoc->GetPoint (pFace->c.i,pFace->c.j);

			DrawTriangle (iFacette,pFace,pt1,pt2,pt3);
		}

		glEnd ();
		break;

	}


	glActiveTextureARB(GL_TEXTURE1_ARB); 
	glDisable(GL_TEXTURE_2D); 
	glActiveTextureARB(GL_TEXTURE0_ARB); 
	glDisable(GL_TEXTURE_2D); 


}


// Dessine un triangle du terrain avec le multi texturing.
void COpenglView::DrawTriangle (int no,FACETTE_TERRE * pFace,POINTASC_TERRE * pt1,POINTASC_TERRE * pt2,POINTASC_TERRE * pt3)
{
	// MODE NORMAL DE FACETTE
	if (!bSmooth) glNormal3f (pFace->n.x,pFace->n.y,pFace->n.z);
	
	// POINT 1
	if (bSmooth) glNormal3f (pt1->n.x,pt1->n.y,pt1->n.z);
	
	if (bTexture)
	{
		glMultiTexCoord2fARB (GL_TEXTURE0_ARB,pt1->tx,pt1->ty);
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pFace->a.i,pFace->a.j);
	
	}
	glVertex3f (pt1->x,pt1->y,pt1->z);



	// POINT 2
	if (bSmooth) glNormal3f (pt2->n.x,pt2->n.y,pt2->n.z);
	
	if (bTexture)
	{
		glMultiTexCoord2fARB (GL_TEXTURE0_ARB,pt2->tx,pt2->ty);
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pFace->b.i,pFace->b.j);
	}
	glVertex3f (pt2->x,pt2->y,pt2->z);

	// POINT 3
	if (bSmooth) glNormal3f (pt3->n.x,pt3->n.y,pt3->n.z);
	if (bTexture)
	{
		glMultiTexCoord2fARB (GL_TEXTURE0_ARB,pt3->tx,pt3->ty);
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pFace->c.i,pFace->c.j);
	}

	glVertex3f (pt3->x,pt3->y,pt3->z);
}




void COpenglView::OnNiveauGrille() 
{
	// TODO: Add your command handler code here
	NiveauType = NIVEAU_GRILLE;
}

void COpenglView::OnNiveauPlan() 
{
	// TODO: Add your command handler code here
	NiveauType = NIVEAU_PLAN;
}

void COpenglView::OnNiveauSquare() 
{
	// TODO: Add your command handler code here
	NiveauType = NIVEAU_SQUARE;

}



void COpenglView :: DrawNiveau ()
{
	int i;
	POINTASC_TERRE * pt;
	POINTASC_TERRE * pt1;

	glColor3f (0,0,1);
	if (NiveauType == NIVEAU_SQUARE || NiveauType == NIVEAU_PLAN)
	{
		glBegin ((NiveauType == NIVEAU_SQUARE) ? GL_LINE_LOOP : GL_QUADS);
		pt = pDoc->GetPoint (0,0);
		glVertex3f (pt->x,pDoc->Hauteur,pt->z);
		pt = pDoc->GetPoint (pDoc->NbPoint-1,0);
		glVertex3f (pt->x,pDoc->Hauteur,pt->z);
		pt = pDoc->GetPoint (pDoc->NbPoint-1,pDoc->NbPoint-1);
		glVertex3f (pt->x,pDoc->Hauteur,pt->z);
		pt = pDoc->GetPoint (0,pDoc->NbPoint-1);
		glVertex3f (pt->x,pDoc->Hauteur,pt->z);
		glEnd ();
		return;
	}

}

// Dessiner la graduation
void COpenglView :: DrawGraduation ()
{
	POINTASC_TERRE * pt;
	int i;

	pt = pDoc->GetPoint (0,0);

	glBegin (GL_LINES);
	for (i = 0; i < pDoc->NbPoint; i++)
	{
		pt = pDoc->GetPoint (0,0);
		glColor3f (1,0,0);
		glVertex3f (pt->x+i*pDoc->Largeur,pDoc->Hauteur,pt->z-pDoc->Largeur);
		glColor3f (0.5,0,0);
		glVertex3f (pt->x+i*pDoc->Largeur,pDoc->Hauteur,pt->z);
		
		glColor3f (0,1,0);
		glVertex3f (pt->x-pDoc->Largeur,pDoc->Hauteur,pt->z+i*pDoc->Largeur);
		glColor3f (0,0.5,0);
		glVertex3f (pt->x,pDoc->Hauteur,pt->z+i*pDoc->Largeur);

		pt = pDoc->GetPoint (0,pDoc->NbPoint-1);
		glColor3f (1,0,0);
		glVertex3f (pt->x+i*pDoc->Largeur,pDoc->Hauteur,pt->z);
		glColor3f (0.5,0,0);
		glVertex3f (pt->x+i*pDoc->Largeur,pDoc->Hauteur,pt->z+pDoc->Largeur);

		pt = pDoc->GetPoint (pDoc->NbPoint-1,0);
		glColor3f (0,1,0);
		glVertex3f (pt->x,pDoc->Hauteur,pt->z+i*pDoc->Largeur);
		glColor3f (0,0.5,0);
		glVertex3f (pt->x+pDoc->Largeur,pDoc->Hauteur,pt->z+i*pDoc->Largeur);
	
	}
	glEnd ();
	
}



void COpenglView::OnConfigTerrain() 
{
	pDoc = GetDocument();
	if (pDoc) 
	{
		pDoc->ConfigTerrain ();	
		SetAllShipOnLandscape ();
	}
}


void COpenglView::DrawCurPoint()
{
	int iFacette;
	int i,j,k;
	POINTASC_TERRE * pt;
	POINTASC_TERRE * pt2;
	int Larg;
	int Haut;
	Larg = pDoc->GetLargeur () / 2;
	Haut = pDoc->Hauteur + 200;
	if (Haut < 500) Haut = 500;




	pDoc->GetCurPoint (i,j);
	pt = pDoc->GetPoint (i,j);
	if (!pt) return;


	glColor3f (1,0,0);

	for (k = 0; k < 6; k++)
	{
		iFacette = pDoc->GetAroundFacette (k,i,j);
		if (iFacette != - 1)
		{
			glBegin (GL_LINE_LOOP);
			pt2 = pDoc->GetPoint (pDoc->Face [iFacette].a.i,pDoc->Face [iFacette].a.j);
			glVertex3f (pt2->x,pt2->y+500,pt2->z);

			pt2 = pDoc->GetPoint (pDoc->Face [iFacette].b.i,pDoc->Face [iFacette].b.j);
			glVertex3f (pt2->x,pt2->y+500,pt2->z);

			pt2 = pDoc->GetPoint (pDoc->Face [iFacette].c.i,pDoc->Face [iFacette].c.j);
			glVertex3f (pt2->x,pt2->y+500,pt2->z);
			glEnd ();
		}

	}

	pDoc->GetMousePointeur (i,j);
	pt = pDoc->GetPoint (i,j);
	if (!pt) return;
	glColor3f (0,1,0);
	glBegin (GL_LINES);
		glVertex3f (pt->x,0,pt->z);
		glVertex3f (pt->x,Haut,pt->z);
	glEnd ();

	GLfloat p1;

	p1 = -pDoc->GetTotalPoint () / 2 * pDoc->Largeur;


	glBegin (GL_LINES);
		glVertex3f (p1,Haut,pt->z);
		glVertex3f (-p1,Haut,pt->z);
		glVertex3f (pt->x,Haut,p1);
		glVertex3f (pt->x,Haut,-p1);
	glEnd ();


}






void COpenglView::OnRender() 
{
	// TODO: Add your command handler code here
	bRender = (bRender) ? FALSE : TRUE;
	if (bRender)
	{
		pDoc = GetDocument();
		pDoc->Render ();
	}
	
}

void COpenglView::OnUpdateRender(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bRender);
	
}


void COpenglView :: Camera (GLfloat oeilx,GLfloat oeily,GLfloat oeilz,GLfloat ciblex,GLfloat cibley,GLfloat ciblez){
	POINTASC vec;
	vec = cam.GetOrientation ();
	gluLookAt(oeilx+vec.x,oeily+vec.y,oeilz+vec.z,ciblex,cibley,ciblez,0,1,0);
}

void COpenglView :: RotateShip (CShip * pVais,GLfloat incx,GLfloat incy,GLfloat incz){
	pVais->Rot (incx,incy,incz);
}

// Effectue une translation sur l'objet 3D
//void COpenglView :: TranslateObjet (CShip * pVais,int inc)
void COpenglView :: TranslateObjet (CShip * pVais)
{
	RotateShip (pVais,0,0,0);
}


// Fait tourner ou avancer le vaisseaux
void COpenglView::MoveShip(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	GLfloat incax,incay;
	RECT rc;
	GetClientRect (&rc);
		if (pVaisSelected && !bShift)
		{
			if (nFlags & MK_RBUTTON)
			{
				
				incax = incay = 0;

				if (ptMemShip.x< point.x)	incay = (float) ANINC* (point.x - ptMemShip.x);
				else				incay = (float) -ANINC* (ptMemShip.x - point.x);
				
				RotateShip (pVaisSelected,incax,incay,0);
			}


		}
		
	ptMemShip = point;
}


// #define DEPX			((TERRAIN_COTE_X * NPOINT) / 2)
// #define DEPZ			((TERRAIN_COTE_Z * NPOINT) / 2)




// Initialise la hauteur du point
BOOL COpenglView :: SetShipY (CShip * pVais)
{
	GLfloat y;
	GLfloat a,b,c,d;
	int iFacetteTriangle;
	int NbPoint;
	int iFacette;

	float val1,val2;
	int i,j;
	float dist1,dist2;
	POINTASC_TERRE *A,*B,*C;


	NbPoint = pDoc->GetTotalPoint ();

	i = (pVais->x - pDoc->Dep) / pDoc->Largeur;
	j = (pVais->z - pDoc->Dep) / pDoc->Largeur;



	if (i < 0) i = 0;
	if (j < 0) j = 0;
	if (i >= NbPoint-2) i = NbPoint-2;
	if (j >= NbPoint-2) j = NbPoint-2;

	if (pVaisSelected == pVais)
	{
		icam = i;
		jcam = j;
	}

	POINTASC_TERRE * pttri;

	pttri = pDoc->GetPoint (i+1,j);
	val1 = pVais->x-pttri->x;
	val2 = pVais->z-pttri->z;
	dist1 = sqrtf (val1*val1 + val2*val2);

	pttri = pDoc->GetPoint (i,j+1);
	val1 = pVais->x-pttri->x;
	val2 = pVais->z-pttri->z;
	dist2 = sqrtf (val1*val1 + val2*val2);


	iFacette = pVais->GetIndexFacette ();
	
	// Calcul de l'index du carre des deux triangle concerns
	iFacetteTriangle = (((j * (NbPoint-1)) + i) * 2)+1;

	// Prendre le bon triangle car dans un carre il y en a deux
	if (dist1 >= dist2)	iFacetteTriangle -= 1;
	pVais->SetIndexFacette (iFacetteTriangle);
	

	// Mettre l'orientation du vaisseau que si le triangle a chang
	FACETTE_TERRE * pFace;
	pFace = pDoc->GetFacette (iFacetteTriangle);

	if (pFace && iFacetteTriangle != iFacette) 
	{
		A = pDoc->GetPoint (i,j);
		B = pDoc->GetPoint (i+1,j+1);
		if (dist1 < dist2)	C = pDoc->GetPoint (i+1,j);
		else				C = pDoc->GetPoint (i,j+1);


		a = A->y*(B->z-C->z) + B->y*(C->z-A->z) + C->y*(A->z-B->z);
		b = A->z*(B->x-C->x) + B->z*(C->x-A->x) + C->z*(A->x-B->x);
		c = A->x*(B->y-C->y) + B->x*(C->y-A->y) + C->x*(A->y-B->y);
		d = A->x* (B->y*C->z - C->y*B->z) 
		+ B->x* (C->y*A->z - A->y*C->z) 
		+ C->x* (A->y*B->z - B->y*A->z);
		d = -d;
		y = (-a*pVais->x -c*pVais->z - d) / b;

		pVais->SetY (y);
		
		pVais->SetOrientation (pFace->n.x,pFace->n.y,pFace->n.z,iFacetteTriangle);
	}

	return TRUE;

}





void COpenglView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CShip * pVais;
	int count,i;
	
	count = ShipList.GetCount ();
	for (i = 0; i < count ; i++)
	{
		pVais = ShipList.GetShip (i);
		if (!pVais) continue;
		
		pVais->Deplace ();
		SetShipY (pVais);
		TranslateObjet (pVais);
	}

	
	CView::OnTimer(nIDEvent);
}

void COpenglView::OnLumiereRaz() 
{
	// TODO: Add your command handler code here
	Pos [0] = 0;
	Pos [2] = 0;
	Pos [1] = 2000;
	Pos [3] = 0;
}


void COpenglView::OnUpdateCalculPente(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (pVaisSelected != NULL);
	
}






BOOL COpenglView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return FALSE;
}



//#define SPHERIQUE_WORLD_SCALE	 500000
#define SPHERIQUE_WORLD_SCALE	 60000

void COpenglView :: DrawSpheriqueWorld ()
{
	glEnable (GL_TEXTURE_2D);
	if (!pObjWorld || pObjWorld->noCallListe == -1) return;
	
	glColor4f (1,1,1,0.8f);
	glScalef (SPHERIQUE_WORLD_SCALE,SPHERIQUE_WORLD_SCALE,SPHERIQUE_WORLD_SCALE);
	glCallList (pObjWorld->noCallListe);
	glDisable (GL_TEXTURE_2D);

}










void COpenglView :: GetSelectedShip (BOOL bSens){
	
	switch (bSens)
	{
		case SHIP_PREV : SelectedShipIndex--;break;
		case SHIP_NEXT : SelectedShipIndex++;break;
	}
	

	if (SelectedShipIndex >= ShipList.GetCount ()) SelectedShipIndex = 0;
	else if (SelectedShipIndex < 0) SelectedShipIndex = ShipList.GetCount () - 1;

	pVaisSelected = ShipList.GetShip (SelectedShipIndex);
	SetShipOnLandscape ();
}


int  fSkySize = 100000;
int iTextureSky = 1;
int iSkySlices	= 10;
float fSkyTexMul = 1;
float fWorldR	= 100000;
float fSkyHeight = 50000;
float c = 2;
void COpenglView::DrawSky()
{
	float d0,d1;
	float z0,z1;
	float light0,light1;
	unsigned char i;
	unsigned char j;



	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, iTextureSky);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);//GL_MODULATE GL_REPLACE
	glBindTexture (GL_TEXTURE_2D,0);

	glDisable (GL_CULL_FACE);


	for(int y=(int)-fSkySize; y<(int)fSkySize; y+=(int)(fSkySize/iSkySlices))
	{
		glBegin(GL_QUAD_STRIP);

		for(int x=(int)-fSkySize; x<=(int)fSkySize; x+=(int)(fSkySize/iSkySlices))
		{	
			i = x;
			j = y;

			d0 = sqrt((float)x*(float)x + (float)y*(float)y);
			d1 = sqrt((float)x*(float)x + (float)(y+fSkySize/c)*(float)(y+fSkySize/iSkySlices));

			z0 = fWorldR - sqrt(fWorldR*fWorldR - d0*d0);
			z1 = fWorldR - sqrt(fWorldR*fWorldR - d1*d1);
			
			light0 = d0 / fSkySize;
			light1 = d1 / fSkySize;

			glTexCoord2f(fSkyTexMul * (x+0), fSkyTexMul * (y+0));
			glVertex3f((float)x+0,  fSkyHeight - z0,(float)y+0);

			glTexCoord2f(fSkyTexMul * (x+0), fSkyTexMul * (y+fSkySize/iSkySlices));
			glVertex3f((float)x+0,fSkyHeight - z1,(float)y+fSkySize/iSkySlices);
		}
		glEnd();
	}
}


void COpenglView :: NewMissil ()
{
	CMissile * pMissil;
	GLfloat dx,dy,dz;
	POINTASC point;
	GLfloat vitesse;

	// Pas de vaisseau slectionn alors pas de missil
	if (pVaisSelected == NULL) return;


	vitesse = VITESSE_MISSILE_MAX + pVaisSelected->vitesse;
	if (vitesse < 0) vitesse = VITESSE_MISSILE_MAX;

	dx = pVaisSelected->matref [8] * vitesse;
	dy = pVaisSelected->matref [9] * vitesse;
	dz = pVaisSelected->matref [10] * vitesse;

	// Cration du missil
	pMissil = new CMissile (
		pVaisSelected->x,
		pVaisSelected->y+100,
		pVaisSelected->z,
		dx,dy,dz,pVaisSelected->matref);
	
	// Probleme d'allocation memoire alors on ne fait rien
	if (!pMissil) return;

	// Ajouter le missile  la liste
	MissilList.AddTail (pMissil);

}


void COpenglView :: SetShipOnLandscape ()
{
	if (pVaisSelected == NULL) return;
	pVaisSelected->SetIndexFacette (-1);
	SetShipY (pVaisSelected);
}

void COpenglView :: SetAllShipOnLandscape ()
{
	CShip * pVais;
	int i,count;

	count = ShipList.GetCount ();

	for (i = 0; i < count; i++)
	{
		pVais = ShipList.GetShip (i);
		if (pVais) 
		{
			pVais->SetIndexFacette (-1);
			SetShipY (pVais);
		}
	}

}


void COpenglView :: ResetView ()
{
	cote = pDoc->Largeur * pDoc->GetTotalPoint () * 2;
	xt = 0;
	yt	= - pDoc->Hauteur;
	zt = - pDoc->GetTotalPoint () * pDoc->GetLargeur ();

	wAngleY = 0.0f;
	wAngleX = 45;
	wAngleZ = 0.0f;


}
